DEFINT A-Z
'$DYNAMIC
'$INCLUDE: 'QBX.BI'   'use QB.BI if using QB45!!!
DECLARE SUB DoScreen ()
DECLARE SUB BlockMove ()
DECLARE SUB MaskToArr (temp$, AnSpriteArray%())
DECLARE SUB LeftShift (SEG Target AS ANY, BYVAL SourceSeg%, BYVAL SourceOff&, BYVAL BytesToMove%, BYVAL Planes%, BYVAL BytesPerPlane&, BYVAL RowsToMove%, BYVAL BytesPerRow&, BYVAL NumBits%)
DECLARE FUNCTION ArraySize& (x1!, x2!, y1!, y2!)
DECLARE SUB GetScreen ()
DIM SHARED StartX%, StartY%, ColorMod%
DIM SHARED DisableInt%, EnableInt%, BitsPP%, Planes%, CMode%, Size&
DIM SHARED BytesToMove%, RowsToMove%, BytesPerPlane&, BytesPerRow&
'$STATIC
DIM SHARED Bits%(15)
'$DYNAMIC
REDIM SHARED ScreenArray%(0 TO 32766)
REDIM SHARED BackArray%(0 TO 15)
REDIM SHARED SpriteArray%(0 TO 15)
REDIM SHARED MaskArray%(0 TO 15)
DIM TheScreens%(1 TO 15)
CONST C$ = "Created 11/06/92 by Steve Gartrell."
	TheScreens%(1) = 1
	TheScreens%(2) = 2
	TheScreens%(3) = 7
	TheScreens%(4) = 8
	TheScreens%(5) = 9
	TheScreens%(6) = 11
	TheScreens%(7) = 12
	TheScreens%(8) = 13
	DisableInt% = &HCBFA
	EnableInt% = &HCBFB
	Bits%(0) = 1
	FOR cnt% = 1 TO 14
		Bits%(cnt%) = Bits%(cnt% - 1) + Bits%(cnt% - 1)
	NEXT
	Bits%(15) = -32768
	ScrCnt% = 1
	DO
		SCREEN TheScreens%(ScrCnt%)
		GetScreen
		DoScreen
		StartX% = 160: StartY% = 100
		ToggleY% = 1
		ToggleX% = -1
		DO
			StartY% = StartY% + ToggleY%
			IF StartY% < 1 OR StartY% > 178 THEN
				IF ToggleY% = -1 THEN
					ToggleY% = 1
				ELSE
					ToggleY% = -1
				END IF
			END IF
			StartX% = StartX% + ToggleX%
			IF StartX% < 1 OR StartX% > 298 THEN
				IF ToggleX% = -1 THEN
					ToggleX% = 1
				ELSE
					ToggleX% = -1
				END IF
			END IF
			cnt% = 0
			BlockMove
			a$ = UCASE$(INKEY$)
		LOOP UNTIL LEN(a$)
		IF a$ = "Q" THEN EXIT DO
		ScrCnt% = ScrCnt% + 1
		IF ScrCnt% = 9 THEN ScrCnt% = 1
	LOOP
	SCREEN 0
	WIDTH 80
	COLOR 7, 0
	END

REM $STATIC
FUNCTION ArraySize& (x1!, x2!, y1!, y2!)
	ArraySize& = 4 + INT(((PMAP(x2!, 0) - PMAP(x1!, 0) + 1) * BitsPP% + 7) / 8) * Planes% * (PMAP(y2!, 1) - PMAP(y1!, 1) + 1)
END FUNCTION

SUB BlockMove
DIM SourceByteOffset&, SourceStartBitOffset%
DIM SourceBitsToRotate%
	SourceByteOffset& = (BytesPerRow& * (StartY%))
'then any particular column starts at byte
' ROW OFFSET + (Bits-per-plane * COLUMN)
	SourceStartBitOffset% = BitsPP% * (StartX%)
	SourceStartByteOffSet& = SourceByteOffset& + (SourceStartBitOffset% \ 8) + 4
'Bits must end up on a word boundary, so we'll rotate left
' via ASM (poor, intentionally handicapped Basic...)
	SourceBitsToRotate% = SourceStartBitOffset% MOD 8
	LeftShift BackArray%(2), VARSEG(ScreenArray%(0)), SourceStartByteOffSet&, BytesToMove%, Planes%, BytesPerPlane&, RowsToMove%, BytesPerRow&, SourceBitsToRotate%
	FOR cnt% = 2 TO Size&
		BackArray%(cnt%) = (BackArray%(cnt%) AND MaskArray%(cnt%)) OR SpriteArray%(cnt%)
	NEXT
	CALL Absolute(VARPTR(DisableInt%))
	WAIT &H3DA, 8, 8
	WAIT &H3DA, 8
	CALL Absolute(VARPTR(EnableInt%))
	PUT (StartX%, StartY%), BackArray%, PSET
END SUB

SUB DoScreen
	CIRCLE (165, 100), 9, 4
	PAINT (165, 100), 90, 4
	CIRCLE (165, 100), 8, 4, 0, 3.14
	CIRCLE (165, 100), 9, 90, 3.14, 6.28
	PSET (162, 99), 1
	CIRCLE (162, 99), 3, 1
	PSET (168, 99), 1
	CIRCLE (168, 99), 3, 1
	CIRCLE (165, 103), 3, 1, 3.43, 5.83
'get image leaving 1 pixel background border on all
' four sides  (Just where a 1-pixel border starts
'<<<<Note 3 of 5 notes>>>>            
' varies with resolution; arcs and whatnot...)
	StartX% = 155: StartY% = 90: EndX% = 175: EndY% = 110
	SpCell% = 1
	x1! = StartX%: x2! = EndX%: y1! = StartY%: y2! = EndY%
	Size& = ArraySize&(x1!, x2!, y1!, y2!) \ 2
	BSize& = ArraySize&(0!, 319!, 0!, 199!)
	REDIM BackArray%(0 TO Size&)
	REDIM SpriteArray%(0 TO Size&)
	REDIM MaskArray%(0 TO Size&)
	GET (StartX%, StartY%)-(EndX%, EndY%), SpriteArray%
	BackArray%(0) = SpriteArray%(0): MaskArray%(0) = SpriteArray%(0)
	BackArray%(1) = SpriteArray%(1): MaskArray%(1) = SpriteArray%(1)
	SELECT CASE BitsPP%
		CASE 1
			BitsOn$ = "1"
			BitsOff$ = "0"
		CASE 2
			BitsOn$ = "11"
			BitsOff$ = "00"
		CASE 8
			BitsOn$ = "11111111"
			BitsOff$ = "00000000"
	END SELECT
	Mask$ = ""
	FOR Y% = StartY% TO EndY%
		FOR cnt% = 1 TO Planes%
			FOR X% = StartX% TO EndX%
				IF POINT(X%, Y%) THEN
					Mask$ = Mask$ + BitsOff$
				ELSE
					Mask$ = Mask$ + BitsOn$
				END IF
			NEXT
			StrLen% = LEN(Mask$)
			IF StrLen% MOD 8 THEN
				Mask$ = Mask$ + STRING$(8 - (StrLen% MOD 8), "0")
			END IF
		NEXT
	NEXT
	MaskToArr Mask$, MaskArray%()
	CLS
	FOR a = 0 TO 319
		LINE (a, 0)-(a, 199), a MOD ColorMod%
	NEXT
	LOCATE 1, 1: PRINT "Background = "; LTRIM$(STR$(BSize&)); " bytes.  Screen "; LTRIM$(STR$(CMode%))
'memory hog!!!  But necessary...
	GET (0, 0)-(319, 199), ScreenArray%(0)
'Number of bytes to shift and move in ASM inner loop
	BytesToMove% = BackArray%(0) \ 8
	IF BackArray%(0) MOD 8 THEN
		BytesToMove% = BytesToMove% + 1
	END IF
	RowsToMove% = BackArray%(1)
'GET array(0) is always equal to the number of columns
' per row times the number of bits per plane.  The layout of the
' array is all the bits of plane (x) of row (y) followed by
' all the bits for plane (x + 1) of row y; after all the planes
' are done, you move into plane (x) of row (y + 1) and so forth.
	BitsPerPlane% = ScreenArray%(0)
'There are eight bits to a byte; GET pads an odd number
' of column bits out to a byte with a zero fill
	IF BitsPerPlane% MOD 8 THEN
		BytesPerPlane& = BitsPerPlane% \ 8 + 1
	ELSE
		BytesPerPlane& = BitsPerPlane% \ 8
	END IF
'every row starts at byte (ROW# * #PLANES * BYTES/PLANE)
' where first ROW = 0
	BytesPerRow& = BytesPerPlane& * Planes%
END SUB

SUB GetScreen
DIM regs AS RegType
' video driver interrupt
	intnum% = &H10
' get video mode function
	regs.ax = &HF00
	CALL Interrupt(intnum%, regs, regs)
	CMode% = regs.ax AND 255
	MinX% = 0: MaxX% = 319
	MinY% = 0: MaxY% = 199
	SELECT CASE CMode%
		CASE &H4   'Screen 1
			BitsPP% = 2: Planes% = 1
			CMode% = 1
			ColorMod% = 3
		CASE &H6   'Screen 2
			BitsPP% = 1: Planes% = 1
			CMode% = 2
			ColorMod% = 2
		CASE &HD   'Screen 7
			BitsPP% = 1: Planes% = 4
			CMode% = 7
			ColorMod% = 16
		CASE &HE   'Screen 8
			BitsPP% = 1: Planes% = 4
			CMode% = 8
			ColorMod% = 16
		CASE &HF   'Screen 10
			BitsPP% = 1: Planes% = 2
			CMode% = 10
			ColorMod% = 2
		CASE &H10  'Screen 9
			BitsPP% = 1: Planes% = 4
			CMode% = 9
			ColorMod% = 16
		CASE &H11  'Screen 11
			BitsPP% = 1: Planes% = 1
			CMode% = 11
			ColorMod% = 2
		CASE &H12  'Screen 12
			BitsPP% = 1: Planes% = 4
			CMode% = 12
			ColorMod% = 16
		CASE &H13  'Screen 13
			BitsPP% = 8: Planes% = 1
			CMode% = 13
			ColorMod% = 256
	END SELECT
END SUB

SUB MaskToArr (temp$, AnArray%())
	CellCnt% = 2
	StrLen% = LEN(temp$)
	ThisChar% = 1
	DO
		TempVar% = 0
		CharCnt% = 7
lp:     IF MID$(temp$, ThisChar%, 1) = "1" THEN
			TempVar% = TempVar% OR Bits%(CharCnt%)
		END IF
		ThisChar% = ThisChar% + 1
		IF ThisChar% > StrLen% THEN
			AnArray%(CellCnt%) = TempVar%
			EXIT DO
		END IF
		CharCnt% = CharCnt% - 1
		IF CharCnt% < 0 THEN CharCnt% = 15
		IF CharCnt% <> 7 THEN GOTO lp
		AnArray%(CellCnt%) = TempVar%
		CellCnt% = CellCnt% + 1
	LOOP
END SUB

