
;Written in TASM

.Model Medium, Basic
.Code BITMAN

LSHIFT  proc, ByteVal:Word, Bit:Word

        mov     ax,[ByteVal]
        mov     cx,[Bit]
        shl     ax,cl
        ret

LSHIFT  endp

RSHIFT  proc, ByteVal:Word, Bit:Word

        mov     ax,[ByteVal]
        mov     cx,[Bit]
        shr     ax,cl
        ret

RSHIFT  endp

READBIT proc, ByteVal:Word, Bit:Word

        mov     ax,[ByteVal]
        mov     dx,1
        mov     cx,[Bit]
        shl     dx,cl
        test    dx,ax
        je      @1
        mov     ax,1
        jmp     @2
@1:
        xor     ax,ax
@2:
        ret
READBIT endp


RESETBIT proc, ByteVal:Word, Bit:Word

        mov     ax,1
        mov     cx,[Bit]
        shl     ax,cl
        mov     dx,[ByteVal]
        not     dx
        and     ax,dx
        ret

RESETBIT endp

SETBIT  proc, ByteVal:Word, Bit:Word

        mov     ax,1
        mov     cx,[Bit]
        shl     ax,cl
        or      ax,[ByteVal]
        ret

SETBIT  endp

TOGGLEBIT proc, ByteVal:Word, Bit:Word

        mov     ax,1
        mov     cx,[Bit]
        shl     ax,cl
        xor     ax,[ByteVal]
        ret

TOGGLEBIT endp

BAND    proc, ByteVal1:Word, ByteVal2:Word

        mov     ax,[ByteVal1]
        and     ax,[ByteVal2]
        ret

BAND    endp

BOR     proc, ByteVal1:Word, ByteVal2:Word

        mov     ax,[ByteVal1]
        or      ax,[ByteVal2]
        ret

BOR     endp

BXOR    proc, ByteVal1:Word, ByteVal2:Word

        mov     ax,[ByteVal1]
        xor     ax,[ByteVal2]
        ret

BXOR    endp

BOC     proc, ByteVal1:Word

        mov     ax,[ByteVal1]
        not     ax
        ret

BOC     endp

        public  READBIT
        public  TOGGLEBIT
        public  RESETBIT
        public  SETBIT
        public  RSHIFT
        public  LSHIFT
        public  BXOR
        public  BOR
        public  BAND
        public  BOC
        end
