    .Model Medium, Basic
    .code

    WarmBoot proc

        mov     ax,1234h            ;Flag for warm boot
        jmp     short BootCommon

    WarmBoot endp

    ColdBoot proc

        xor     ax,ax               ;Zero ax - flag for cold boot

    BootCommon::
        xor     bx,bx               ;Zero bx
        mov     ds,bx               ;Point DS to bios data area
        mov     ds:[472h],ax        ;Plug the boot flag into the BDA
        mov     ax,0fffh
        push    ax                  ;Push the segment of the ROM Boot
        push    bx                  ; Routine .. and the offset
        retf                        ;An easy way to do a far Jmp

    ColdBoot endp
    end