DEFINT A-Z

DECLARE SUB LoadColorBob (ImgFile$, Img%(), ImgExt%)

DECLARE SUB Welcome ()
DECLARE SUB ColorBobical1 ()
DECLARE SUB ColorBobical2 ()
DECLARE SUB ColorBobical3 ()
DECLARE SUB ByeBye ()

TYPE StarType
  Angle AS INTEGER
  Speed AS INTEGER
  Brite AS INTEGER
  RealX AS INTEGER
  RealY AS INTEGER
  Dis   AS INTEGER
END TYPE

SCREEN 13

RANDOMIZE TIMER

Welcome
ColorBobical1
ColorBobical2
ColorBobical3
ByeBye

END

SIP:
IF t > 5 THEN
  ip = (ip + 1) MOD 5
  IF ip = 0 THEN ip = 1
ELSE
  t = t + 1
END IF
RETURN

SUB ByeBye

SCREEN 0
WIDTH 80
COLOR 15, 3
PRINT "                                                                " + "                "
PRINT "  Well, bye! I hope you enjoyed the demo. I diddn't spend a" + " whole lot of time   "
PRINT "  on it, granted, but it's okay anyways... Have fun!            " + "                "
PRINT "  - Calvin French - FidoNet 1:134/75 (RJ's Byteline)            " + "                "
PRINT "                                                                " + "                "
COLOR 7, 0
PRINT
PRINT
PRINT

END SUB

SUB ColorBobical1

SCREEN 13
CLS

DIM Img(15, 15, 29)

OUT &H3C8, 0
FOR n = 1 TO 255
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
NEXT n

LoadColorBob "!0000001.GFX", Img(), 0
LoadColorBob "!0000002.GFX", Img(), 1
LoadColorBob "!0000003.GFX", Img(), 2
LoadColorBob "!0000004.GFX", Img(), 3
LoadColorBob "!0000005.GFX", Img(), 4
LoadColorBob "!0000006.GFX", Img(), 5
LoadColorBob "!0000007.GFX", Img(), 6
LoadColorBob "!0000008.GFX", Img(), 7
LoadColorBob "!0000009.GFX", Img(), 8
LoadColorBob "!0000010.GFX", Img(), 9
LoadColorBob "!0000011.GFX", Img(), 10
LoadColorBob "!0000012.GFX", Img(), 11
LoadColorBob "!0000013.GFX", Img(), 12
LoadColorBob "!0000014.GFX", Img(), 13
LoadColorBob "!0000015.GFX", Img(), 14

FOR n = 15 TO 29
  FOR x = 1 TO 15
    FOR y = 1 TO 15
      Img(x, y, n) = Img(x, y, 15 - (n - 15))
    NEXT
  NEXT
NEXT

n = 1
FOR y = 1 TO 15
  FOR x = 1 TO 15
    PSET (x, y), n
    n = n + 1
  NEXT x
NEXT y

DIM Temp(5000)
GET (1, 1)-(15, 15), Temp

CLS

FOR y = 0 TO 12
  FOR x = 0 TO 20
    PUT (x * 15 + 3, y * 15 + 3), Temp, PSET
  NEXT x
NEXT y

xn = 1
yn = 1

rs = 1
bs = 2
gs = 3

xp = 1

LOCATE 25, 1
PRINT SPACE$(40);

DO

  IF ballistic THEN
    xn = (xn - yn) MOD 15
    yn = (yn + xn) MOD 15
    xn = xn + RND + 315
    yn = yn + RND + 315
    xn = xn MOD 15
    yn = yn MOD 15
  ELSE
    deg = (deg + 2) MOD 360
    xn = SIN(deg / 55) * 15 + 15
    yn = COS(deg / 55) * 15 + 15
  END IF

  IF supercolor THEN
    r = r + rs
    g = g + gs
    b = b + bs
    IF r = 60 OR r = 0 THEN
      rs = -rs
    END IF
    IF g = 61 OR g = 0 THEN
      gs = -gs
    END IF
    IF b = 62 OR b = 0 THEN
      bs = -bs
    END IF
  END IF

  OUT &H3C8, 1
  FOR x = 1 TO 16
    xa = (xn + x) MOD 15
    FOR y = 1 TO 15
      ya = (yn + y) MOD 15
      IF Img(xa, ya, ip) THEN
        nr = Img(xa, ya, ip) + r
        ng = Img(xa, ya, ip) + g
        nb = Img(xa, ya, ip) + b
      ELSE
        nr = Img(xa, ya, ip)
        ng = Img(xa, ya, ip)
        nb = Img(xa, ya, ip)
      END IF

      OUT &H3C9, nr
      OUT &H3C9, ng
      OUT &H3C9, nb
    NEXT
  NEXT

  IF sp \ 8 > 904 THEN
    supercolor = 1
  END IF

  IF sp \ 8 > 1340 THEN
    ballistic = 1
  END IF

  ip = (ip + 1) MOD 30

LOOP UNTIL LEN(INKEY$)

REDIM Img(0, 0, 0)

END SUB

SUB ColorBobical2

CLS

SCREEN 13

OUT &H3C8, 0
FOR n = 1 TO 63
  OUT &H3C9, n
  OUT &H3C9, n
  OUT &H3C9, n
NEXT n

DIM Stars(1 TO 200) AS StarType
DIM Stars1(1 TO 200) AS StarType
DIM Stars2(1 TO 200) AS StarType
DIM Stars3(1 TO 200) AS StarType
DIM OldStars(1 TO 200) AS StarType

FOR n = 1 TO 200

  Stars1(n).Angle = RND * 360
  Stars1(n).Speed = RND * 3 + 1
  Stars1(n).Brite = RND * 10
  Stars1(n).Dis = RND * 200

  Stars2(n).Angle = (n * 3.6) MOD 360
  Stars2(n).Speed = 2
  Stars2(n).Brite = 1
  Stars2(n).Dis = (n * 25) MOD 200

  IF n MOD 3 = 0 THEN
    Stars3(n).Angle = (n * 3.6) MOD 360
    Stars3(n).Speed = 3
    Stars3(n).Brite = 1
    Stars3(n).Dis = n
  ELSEIF n MOD 3 = 1 THEN
    Stars3(n).Angle = ((n + 33) * 3.6) MOD 360
    Stars3(n).Speed = 3
    Stars3(n).Brite = 1
    Stars3(n).Dis = n
  ELSEIF n MOD 3 = 2 THEN
    Stars3(n).Angle = ((n + 66) * 3.6) MOD 360
    Stars3(n).Speed = 3
    Stars3(n).Brite = 1
    Stars3(n).Dis = n
  END IF

NEXT n

DIM S(360) AS INTEGER
DIM C(360) AS INTEGER

FOR n = 0 TO 360
  S(n) = SIN(n / 57.32) * 100 * 1.2
  C(n) = COS(n / 57.32) * 100
NEXT n

CLS

REDIM Temp(5000)

FOR n = 1 TO 200
  Stars(n).Angle = Stars1(n).Angle
  Stars(n).Speed = Stars1(n).Speed
  Stars(n).Brite = Stars1(n).Brite
  Stars(n).Dis = Stars1(n).Dis
NEXT n

DO
  d = (d + 1) MOD 360
  'star.trans.x(n) = (cosine(star.angle(n))) - (sine(star.angle(n))) *  star.dis(n)
  'star.trans.y(n) = (sine(star.angle(n))) + (cosine(star.angle(n))) *  star.dis(n)
  FOR n = 1 TO 200
    Stars(n).RealX = 160 + (C(Stars(n).Angle) - S(Stars(n).Angle) * Stars(n).Dis) \ 100
    Stars(n).RealY = 100 + (S(Stars(n).Angle) + C(Stars(n).Angle) * Stars(n).Dis) \ 100
    IF Stars(n).RealY < 11 THEN Stars(n).RealY = 200
  NEXT n
  FOR n = 1 TO 200
    PSET (OldStars(n).RealX, OldStars(n).RealY), 0
    PSET (Stars(n).RealX, Stars(n).RealY), Stars(n).Brite + Stars(n).Dis \ 3
    OldStars(n).RealX = Stars(n).RealX
    OldStars(n).RealY = Stars(n).RealY
  NEXT n
  IF rotation <> 0 THEN
    FOR n = 1 TO 200
      Stars(n).Dis = (Stars(n).Dis + Stars(n).Speed) MOD 200
      Stars(n).Angle = (Stars(n).Angle + rotation) MOD 360
    NEXT n
  ELSE
    FOR n = 1 TO 200
      Stars(n).Dis = (Stars(n).Dis + Stars(n).Speed) MOD 200
    NEXT n
  END IF
  sp = sp + 1

  OUT &H3C8, 70
  OUT &H3C9, (1 * sp) MOD 40 + 20
  OUT &H3C9, (2 * sp) MOD 40 + 20
  OUT &H3C9, (3 * sp) MOD 40 + 20

  IF sp \ 8 = 122 THEN
    rotation = 1
  END IF

  IF sp \ 8 = 256 THEN
    rotation = 358
  END IF

  IF sp \ 8 = 512 THEN
    rotation = 0
    FOR n = 1 TO 200
      Stars(n).Angle = Stars2(n).Angle
      Stars(n).Speed = Stars2(n).Speed
      Stars(n).Brite = Stars2(n).Brite
      Stars(n).Dis = Stars2(n).Dis
    NEXT n
  END IF

  IF sp \ 8 = 762 THEN
    rotation = 1
  END IF

  IF sp \ 8 = 1024 THEN
    rotation = 358
  END IF

  IF sp \ 8 = 1256 THEN
    rotation = 0
    FOR n = 1 TO 200
      Stars(n).Angle = Stars3(n).Angle
      Stars(n).Speed = Stars3(n).Speed
      Stars(n).Brite = Stars3(n).Brite
      Stars(n).Dis = Stars3(n).Dis
    NEXT n
  END IF

  IF sp \ 8 = 1512 THEN
    rotation = 1
  END IF

  IF sp \ 8 = 1974 THEN
    rotation = 358
  END IF

LOOP UNTIL LEN(INKEY$)

REDIM Stars1(0) AS StarType
REDIM Stars2(0) AS StarType
REDIM Stars3(0) AS StarType

REDIM Stars(0) AS StarType
REDIM OldStars(0) AS StarType

END SUB

SUB ColorBobical3

SHARED ip
SHARED r
SHARED g
SHARED b

DIM ra(4): DIM ga(4): DIM ba(4)

ra(1) = 30: ga(1) = 10: ba(1) = 10
ra(2) = 10: ga(2) = 30: ba(2) = 10
ra(3) = 10: ga(3) = 10: ba(3) = 30
ra(4) = 30: ga(4) = 10: ba(4) = 30

ON TIMER(2) GOSUB SIP

OUT &H3C8, 0
FOR n = 0 TO 255
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
NEXT n

DEF SEG = &HA000
BLOAD "SURPRISE.PIC", 0
DEF SEG

els = 1

TIMER ON

DIM Img(15, 15, 4)

LoadColorBob "FORM0001.GFX", Img(), 0
LoadColorBob "FORM0002.GFX", Img(), 1
LoadColorBob "FORM0003.GFX", Img(), 2
LoadColorBob "FORM0004.GFX", Img(), 3
LoadColorBob "FORM0005.GFX", Img(), 4

DO
  r = ra(ip)
  g = ga(ip)
  b = ba(ip)
  xn = xn + 1
  yn = yn + 1
  el = el + els
  IF el > 40 THEN
    els = -els
  ELSEIF el < 1 THEN
    els = -els
  END IF
  OUT &H3C8, 0
  OUT &H3C9, el
  OUT &H3C9, 0
  OUT &H3C9, 0

  FOR x = 1 TO 15
    xa = (xn + x) MOD 15
    FOR y = 1 TO 15
      ya = (yn + y) MOD 15
      IF Img(xa, ya, ip) THEN
        nr = Img(xa, ya, ip) + r
        ng = Img(xa, ya, ip) + g
        nb = Img(xa, ya, ip) + b
      ELSE
        nr = Img(xa, ya, ip) + el
        ng = Img(xa, ya, ip)
        nb = Img(xa, ya, ip)
      END IF
      OUT &H3C9, nr
      OUT &H3C9, ng
      OUT &H3C9, nb
    NEXT
  NEXT
LOOP UNTIL LEN(INKEY$)

END SUB

SUB LoadColorBob (ImgFile$, Img(), ImgExt)

OPEN ImgFile$ FOR BINARY AS #1
a$ = INPUT$(2, 1)
FOR y = 1 TO 15
  FOR x = 1 TO 15
    Img(x, y, ImgExt) = ASC(INPUT$(1, 1))
  NEXT
NEXT
CLOSE #1

END SUB

SUB Welcome

SCREEN 0
WIDTH 80

COLOR 15, 1
CLS

CLS
PRINT "Hello, and welcome to my demo! It's pretty simple but it's fun" + " to watch"
PRINT "in some parts. Anyways, there's no scrolls or anything, although" + " there"
PRINT "*was*, once apon a time... (I removed them because they slowed" + " things"
PRINT "down WAAY too much). There are three parts to the demo:"
PRINT ""
PRINT "   i) Li'l bouncing colorbobs. Just watch it until the movement" + " starts to"
PRINT "      go 'ballistic', that is, the balls jump around EVERYWHERE."
PRINT "  ii) Starfield. Just watch it until you witness 8 changes."
PRINT " iii) Surprise! Watch it for 10 seconds or so..."
PRINT ""
PRINT "Bye! Calvin French (1:134/75)";
DO: LOOP UNTIL LEN(INKEY$)
CLS
PRINT "Okay let's go..."
END SUB

