' Cesar Crypt version 1, by Glenn Kinen.  In the public domain!
' This uses the simple encryption alagorithm used by Julias Cesar.
' His method was to shift the letter over 3 spaces. What I mean is A = D,
' B = E, and so on. This arcane method easily fails to letter frequency
' analysis. If you wish to use more reliable, and 'stronger' encryption use
' the file CRYPTOR.BAS which accopanies this file. This is just for fun,
' nothing special, just for those who want to know how simple codes work,
' without learning all the compilcated 0's and 1's AND/OR the other stuff.
' (No pun intended, of course!). This accepts command line options in the
' following format: CesCrypt [file [ number of spaces to shift]].

DECLARE SUB GetCommand (status%, file$, spaces%)
DIM CryptionCharacters%(255)
DIM byte AS STRING * 1
CLS
PRINT "Cesar Cryptor! Julias Cesar Encryption alagorithm...": PRINT "Version 1.0": PRINT

GetCommand status%, file$, spaces%
IF status% = 0 THEN
 INPUT "File to CesarCrypt?  ", file$
 INPUT "Number of spaces to shift the letters? ", spaces%
ELSEIF status% = 1 THEN
 INPUT "Number of spaces to shift the letters? ", spaces%
END IF
INPUT "Encrypt, or decrypt (E/D)?  ", Ed$: Ed$ = UCASE$(Ed$)
IF spaces% < 1 OR spaces% > 255 THEN spaces% = 3
'if invalid number uses Julias Cesars shift 3 Method!
IF Ed$ = "" OR file$ = "" THEN END

OPEN file$ FOR BINARY AS #1
IF LOF(1) = 0 THEN PRINT "File not found!": BEEP: CLOSE : KILL file$: END

IF Ed$ = "E" THEN
  FOR i% = 0 TO 255
    IF spaces% + i% <= 255 THEN
      CryptionCharacters%(i%) = spaces% + i%
    ELSE
      CryptionCharacters%(i%) = i% - 255 + spaces%
    END IF
  NEXT
ELSEIF Ed$ = "D" THEN
  FOR i% = 0 TO 255
    IF i% - spaces% >= 0 THEN
      CryptionCharacters%(i%) = i% - spaces%
    ELSE
      CryptionCharacters%(i%) = spaces% + 255 - i%
    END IF
  NEXT
ELSE
  PRINT "Invalid Choice!": BEEP: END
END IF
interVal% = LOF(1) \ 100: IF interVal% = 0 THEN interVal% = 1
DO
 keepCount& = keepCount& + 1
 GET #1, , byte
 IF byte = "" THEN num = 0 ELSE num = ASC(byte)
 byte = CHR$(CryptionCharacters%(num))
 PUT #1, LOC(1), byte
 IF keepCount& MOD interVal% = 0 THEN LOCATE 7: PRINT "Percent Done -"; keepCount& * 100 \ LOF(1)
LOOP UNTIL keepCount& = LOF(1)
LOCATE 7: PRINT "Percent Done - 100": PRINT
PRINT "The Cryption is done! Enjoy!"


SUB GetCommand (status%, file$, spaces%)
' Get the Command Line!
 commandLine$ = RTRIM$(LTRIM$(COMMAND$))
 IF LEN(commandLine$) = 0 THEN EXIT SUB
 seperation% = INSTR(commandLine$, " ")
 SELECT CASE seperation%
  CASE 0: file$ = commandLine$: status% = 1: EXIT SUB
  CASE ELSE
   file$ = LEFT$(commandLine$, seperation% - 1)
   spaces% = VAL(RIGHT$(commandLine$, LEN(commandLine$) - seperation%))
   status% = 2
END SELECT

END SUB

