; DAYTEST.ASM
; November 14, 1990 - JOHN OLSON
;
CODE    SEGMENT PARA PUBLIC 'CODE'
        ASSUME  CS:CODE,DS:CODE
        ORG     100H
START:
        PUSH    DS

        MOV     AX,CS
        MOV     ES,AX
        MOV     DS,AX

        XOR     AX,AX
        PUSH    AX
        JMP     START0

FCB:    DB      0,'??',7FH,'??',7FH,'??_&_',32 DUP(0)
FILE0:
        DB      '??',7FH,'??',7FH,'??._&_',0

FILE1:
MONTH   DB      '  ',7FH
DAY     DB      '  ',7FH
YEAR    DB      '  ._&_',0

START0:
        MOV     AH,2AH                  ; GET DATE
        INT     21H

        SUB     CX,1900                 ; Adjust year > 80+
        PUSH    CX                      ; YEAR
        PUSH    DX
        MOV     AL,DH                   ; Month
        MOV     DI,Offset MONTH
        CALL    BIN2ASC

        POP     DX
        MOV     AL,DL                   ; DAY
        MOV     DI,Offset DAY
        CALL    BIN2ASC

        POP     AX                      ; YEAR (80-199)
        CMP     AL,100
        JB      SKIP
        SUB     AL,100
SKIP:
        MOV     DI,Offset YEAR
        CALL    BIN2ASC

EXISTS:
        MOV     AH,4EH                  ; Find First
        MOV     CX,20H
        MOV     DX,Offset FILE1
        INT     21H
        JNC     EXIT1

DELETE:
        MOV     AH,13H
        MOV     DX,Offset FCB
        INT     21H
;
CREATE:
        MOV     AH,3CH
        MOV     CX,20H
        MOV     DX,Offset FILE1
        INT     21H
        JC      ERRXIT
EXIT0:
        MOV     AL,0
        JMP     Short EXIT
EXIT1:
        MOV     AL,1
        JMP     Short EXIT
ERRXIT:
        MOV     AL,0FFH
EXIT:
        MOV     AH,4CH          ; Quit with Exit Code
        INT     21H

;*****************
;
BIN2ASC:
        AAM
        ADD     AX,3030H
        XCHG    AH,AL
        CLD
        STOSW
        RET

CODE    ENDS
        END     START
