DEFINT A-Z

'This program is COPYRIGHTed 1991 by KEN PREVO -- ALL RIGHTS RESERVED
'The user is granted a limited license to use and adapt this program
'for their not-for-profit use. Any dirivitive works will retain the
'original copyright of Ken Prevo and this copyright must be displayed
'by the program. 12/15/91 /s/ Ken Prevo

'Name:      CC.EXE(BAS)
'Purpose:   Create program with conditional Compiling instructions
'Version:   1.0
'Copyright 1989 by Ken Prevo -- ALL RIGHTS RESERVED

DECLARE SUB ShoCmd ()
DECLARE SUB ToScreen ()

CONST True = -1
CONST False = 0
IF COMMAND$ > "" THEN
    f$ = COMMAND$
    User% = False
ELSE
    COLOR 8, 0
    PRINT "Portions copyrighted by Microsoft 1989 and before";
    SLEEP 1
    LOCATE CSRLIN, 1
    COLOR 15, 0
    PRINT "       ***  Ken's Conditional Compiler ***           "
    PRINT "Copyright 1989 by Ken Prevo -- All Rights Reserved --"
    COLOR 7, 0
    LINE INPUT "Name of file to process: "; f$
    User% = True
END IF
PRINT
CALL exist(f$ + CHR$(0), ok%)
IF NOT ok% THEN
    PRINT "File Not Found: "; f$
    END
END IF
OPEN "I", 1, f$
LINE INPUT #1, x$
IF LEFT$(RTRIM$(UCASE$(x$)), 8) = "'@OUTPUT" THEN
    o$ = RTRIM$(MID$(x$, INSTR(x$, " ") + 1))
    CALL exist(o$ + CHR$(0), ok%)
    IF ok% THEN                         'check date for need to update
        CALL FindFirstF(o$ + CHR$(0), 0, errcd%)
        IF errcd% = 0 THEN
            CALL GetDateF(d1%(1), d1%(2), d1%(3))
            CALL GetTimeF(T1%(1), T1%(2), T1%(3))
            CALL FindFirstF(f$ + CHR$(0), 0, errcd%)
            CALL GetDateF(d2%(1), d2%(2), d2%(3))
            CALL GetTimeF(T2%(1), T2%(2), T2%(3))
            x% = (d1%(3) - d2%(3)) * 365 + (d1%(1) - d2%(1)) * 31 + (d1%(2) - d2%(2))
            IF x% >= 0 THEN ' then the new file is current to the day or better
                IF x% > 0 OR t% > 0 THEN 'either after date or same date but later in day
                   PRINT o$; " was created after last edit -- Nothing required"
                   END
                END IF
            END IF
        END IF
    END IF
    LINE INPUT #1, x$
ELSE
    o$ = "TEMP.$$$"
END IF
OPEN "O", 2, o$
'x$ now contains next line to process
'Defaults:
BatName$ = "$$$.BAT"
LinkName$ = "LINK"
AfterLink$ = ";"
CompName$ = "BC"
AfterComp$ = ";"

PassThru% = True           'Should the current line be printed
Defined$ = ""             'contains defined items delimited by 

IF ENVIRON$("CC") > "" THEN 'add the environment variable to the defined list
    Delimit$ = Defined$ + RTRIM$(LTRIM$(UCASE$(x$))) + Defined$
    FOR i% = 1 TO LEN(x$)
        IF INSTR(" ," + CHR$(9), MID$(Delimit$, i%, 1)) THEN
            MID$(Delimit$, i%, 1) = Defined$
        END IF
    NEXT
ELSE
    Delimit$ = Defined$     '""-contains defined items delimited by 
END IF

More% = True
DO WHILE More%          'process to end of input file  ***** MAIN LOOP *****
    IF EOF(1) THEN More% = NOT More%
    p$ = LTRIM$(x$)
    IF LEFT$(p$, 2) = "'@" THEN 'act on preprocessor selection
        p$ = RTRIM$(UCASE$(p$))
        p% = INSTR(p$, " ")
        IF p% = 0 THEN p% = LEN(p$)         'for short commands
        CmdParam$ = RTRIM$(LEFT$(p$, p%))
        IF NOT PassThru% AND CmdParam$ <> "'@END" AND CmdParam$ <> "'@ELSE" THEN
            CALL ToScreen
        ELSE
            CmdParam$ = MID$(CmdParam$, 3)                 'drop the '$
            IF p% < LEN(p$) THEN
                tmp$ = RTRIM$(LTRIM$(MID$(p$, p%)))'temporary storage of rest of line
            ELSE
                tmp$ = ""
            END IF
            SELECT CASE CmdParam$
              CASE "IF"
                Ck$ = Delimit$ + tmp$ + Delimit$
                IF INSTR(Defined$, Ck$) > 0 THEN
                   PassThru% = True%
                ELSE
                   PassThru% = False%
                END IF
                CALL ShoCmd
              CASE "ELSE"
                PassThru% = NOT PassThru%
                CALL ShoCmd
              CASE "END"
                PassThru% = True%
                CALL ShoCmd
              CASE "ASK"        'stop, display prompt, ask for y/n answer
                COLOR 31, 1
                LOCATE 25, 1
                PRINT "?   ";
                PRINT USING "\" + SPACE$(74) + "\"; tmp$;
                LOCATE 25, 1
                DO
                    q$ = ""
                    WHILE q$ = ""
                        q$ = INKEY$
                    WEND
                    q$ = UCASE$(q$)
                LOOP UNTIL INSTR("YyNn", q$) > 0
                COLOR 12, 0
                IF q$ = "Y" THEN
                    PRINT "Yes";
                    PassThru% = True
                    p1% = INSTR(tmp$, "[")
                    IF p% > 0 THEN
                        p2% = INSTR(tmp$, "]")
                        IF p2% > p1% THEN
                            Defined$ = Defined$ + MID$(tmp$, p1% + 1, p2% - p1% - 1) + Delimit$
                        END IF
                    END IF
                ELSE
                    PRINT "No";
                    PassThru% = False
                END IF
                LOCATE 24, 1      'SPECIAL COLORS TO SIGNIFY ASK
                IF User% THEN
                   IF PassThru% THEN
                       COLOR 12, 0
                   ELSE
                       COLOR 4, 0
                   END IF
                END IF
                PRINT p$
              CASE "SET"        'Activate a definition
                IF PassThru% THEN Defined$ = Defined$ + tmp$ + Delimit$
                CALL ShoCmd
              CASE "DATE"       'insert the current date as a variable
                CALL ShoCmd
                IF PassThru% THEN
                    x$ = tmp$ + " = " + CHR$(34) + DATE$ + CHR$(34)
                    'x$ = LEFT$(x$, LEN(x$) - 4) + RIGHT$(x$, 2)
                    PRINT #2, x$
                    IF User% THEN CALL ToScreen
                END IF
              CASE "INCLUDE"
                CALL ShoCmd
                IF PassThru% THEN
                    CALL exist(tmp$ + CHR$(0), ok%)
                    IF ok% THEN
                        CALL ToScreen
                        OPEN "I", 3, tmp$
                        PRINT #2, "'@@@@@@ INCLUDE OF "; tmp$; " @@@@@@"
                        DO WHILE NOT EOF(3)
                            LINE INPUT #3, x$
                            PRINT #2, x$
                            CALL ToScreen
                        LOOP
                        PRINT #2, "'@@@@@@ END OF INCLUDE OF "; tmp$; " @@@@@@"
                    ELSE
                        COLOR 31, 0
                        PRINT "Missing INCLUDE file: "; tmp$; " -- Cannot Continue!"
                        END
                    END IF
                END IF
              CASE "ZIP"        'define the .ZIP and how to update
                CALL ShoCmd
                IF PassThru% THEN Zip$ = tmp$
              CASE "BATCH"      'name of the batch file
                CALL ShoCmd
                IF PassThru% THEN BatName$ = MID$(x$, p% + 1)
              CASE "COMPNAME"
                CALL ShoCmd
                IF PassThru% THEN CompName$ = MID$(x$, p% + 1)
              CASE "AFTERCOMP"
                CALL ShoCmd
                IF PassThru% THEN AfterComp$ = MID$(x$, p% + 1)
              CASE "LINKNAME"
                CALL ShoCmd
                IF PassThru% THEN LinkName$ = MID$(x$, p% + 1)
              CASE "AFTERLINK"
                CALL ShoCmd
                IF PassThru% THEN AfterLink$ = MID$(x$, p% + 1)
              CASE ELSE
                CALL ShoCmd
                PRINT "Ooops! "; x$
            END SELECT
        END IF 'PassThru% and not '@END
    ELSE    'its a valid line
        IF PassThru% THEN
            PRINT #2, x$
        END IF
        IF User% THEN CALL ToScreen
    END IF
    IF More% THEN LINE INPUT #1, x$
LOOP
CLOSE
'Now write the batch file
OPEN "O", 1, BatName$
PRINT #1, CompName$; " "; f$; " "; AfterComp$
PRINT #1, "IF ERRORLEVEL = 0 GOTO OK"
PRINT #1, "ECHO Compile of "; f$; " failed"
PRINT #1, "PAUSE"
PRINT #1, "GOTO FINI"
PRINT #1, ":OK"
p% = INSTR(f$, ".")
IF p% > 0 THEN
    f$ = LEFT$(f$, p%) + "OBJ"
END IF
PRINT #1, LinkName$; " "; AfterLink$
PRINT #1, "IF ERRORLEVEL = 0 THEN GOTO OK2"
PRINT #1, "ECHO Linkage Failed for "; f$
PRINT #1, "GOTO FINI"
PRINT #1, ":OK2"
IF Zip$ > "" THEN PRINT #1, Zip$
PRINT #1, ":FINI"
IF NOT User% THEN PRINT #1, "EXIT"
CLOSE
IF NOT User% THEN
    LOCATE 24, 1
    SHELL BatName$
    PRINT
END IF

DEFINT A-Z
SUB ShoCmd STATIC
    SHARED PassThru%, p$, User%
    IF NOT User% THEN EXIT SUB
    IF PassThru% THEN
        COLOR 14, 0
    ELSE
        COLOR 6, 0
    END IF
    PRINT p$
END SUB

DEFINT A-Z
SUB ToScreen STATIC
    SHARED PassThru%, x$
    LOCATE 24, 1
    IF PassThru% THEN
        COLOR 15, 0
    ELSE
        COLOR 7, 0
    END IF
    PRINT x$
END SUB

