'*** MOV-RSIZ.BAS Public Domain by Jimmy Hawkins
DEFINT A-Z
DECLARE SUB BoxMove (URd%, LCd%, LRd%, RCd%, Row%, col%, Shade%)
DECLARE SUB BoxReSize (Uprow%, Ltcol%, Row%, col%, Shade%)
'***
DECLARE SUB DrawBox (Ulr%, Ulc%, Lrr%, Lrc%, BAttrib%, BType%, WAttrib%, Shade%)
DECLARE SUB MemCopy (fromseg, fromoff, VidSeg%, destoff, nbytes)
DECLARE SUB RestScrn (Scr%())
DECLARE SUB SaveScrn (Scr%())
'*** mice!
'$INCLUDE: 'qbx.bi'
DECLARE SUB MouseOn ()
DECLARE SUB MouseOff ()
DECLARE SUB MouseSetHorz (Min%, Max%)
DECLARE SUB MouseSetVert (Min%, Max%)
DECLARE SUB MouseLocate (Xpos%, Ypos%)
DECLARE SUB MouseStatus (Row%, col%, MButtons$)
DECLARE FUNCTION MouseInstalled% ()
'*** dims
DIM SHARED ScrA%(4000)
DIM SHARED RegX AS RegTypeX
DIM Msg$(1 TO 254)
'***
COMMON SHARED VidSeg%
DEF SEG = &H40
equip = PEEK(&H10)
IF (equip AND 48) = 48 THEN
   VidSeg% = &HB000
ELSE
   VidSeg% = &HB800
   Shade% = -1
END IF

Msg$(1) = CHR$(24) + " Move Me!"
Msg$(2) = "Resize Me! " + CHR$(25)
'*** we can throw anything at the print routine
FOR Cnt% = 3 TO 254
   Msg$(Cnt%) = STRING$(81, (Cnt% + 62))
NEXT
COLOR 0, 7: CLS : SHELL "dir *.* /w /p": SaveScrn ScrA(): COLOR 7, 1

Uprow% = 10: Ltcol% = 21: Lorow% = 13: Rtcol% = 34
DEF SEG = VidSeg%
CALL DrawBox(Uprow%, Ltcol%, Lorow%, Rtcol%, 31, 2, 16, Shade%)
GOSUB BoxPrint

CALL MouseSetHorz(1, 80): CALL MouseSetVert(1, 25)
CALL MouseLocate(13, 34): CALL MouseOn
DO
   CALL MouseStatus(Row%, col%, MButtons$)
   '*** BoxMove  (Lmouse on box's upper left corner)
   IF ((MButtons$ = "L  ") AND (Row% = Uprow) AND (col% = Ltcol)) THEN
	  '*** LRd = LowerRowDiff (Lower row of box - mouse) ...
	  LRd% = (Lorow% - Row%) + 1
	  RCd% = (Rtcol% - col%) + 1
	  CALL BoxMove(URd%, LCd%, LRd%, RCd%, Row%, col%, Shade%)
	  Uprow = Row%
	  Ltcol = col%
	  Lorow = LRd + Row% - 1
	  Rtcol = RCd + col% - 1
	  GOSUB BoxPrint
   '*** BoxReSize  (Rmouse on box's lower right corner)
   ELSEIF ((MButtons$ = "  R") AND (Row% = Lorow%) AND (col% = Rtcol%)) THEN
	  CALL BoxReSize(Uprow%, Ltcol%, Row%, col%, Shade%)
	  Lorow% = Row%
	  Rtcol% = col%
	  GOSUB BoxPrint
   END IF

   a$ = INKEY$
   IF a$ <> "" THEN CALL MouseOff: COLOR 7, 1: CLS : DEF SEG : END
   LOOP
END

BoxPrint:
'***  mabey if we ask Coridon Henshaw real nice, he'd post
'***  his VMENU print routines again...
   COLOR 30, 1: MaxMsgWidth% = (Rtcol% - Ltcol%) - 1
   IF MaxMsgWidth THEN
	  DO WHILE ((ii <= Cnt% - 1) AND ((Lorow% - Uprow%) > (ii + 1)))
		 ii = ii + 1
		 LOCATE (Uprow% + ii), (Ltcol% + 1), 0
		 PRINT LEFT$(Msg$(ii), MaxMsgWidth);
	  LOOP
   END IF
   LOCATE Uprow%, Ltcol%, 0: PRINT CHR$(240)
   LOCATE Lorow, Rtcol%, 0: PRINT CHR$(240)
COLOR 7, 1: ii = 0
RETURN

'******
SUB BoxMove (URd%, LCd%, LRd%, RCd%, Row%, col%, Shade%)
   '*** IMPORTANT! eliminates the need for any error checking
   CALL MouseSetHorz(1, (79 - RCd%))
   CALL MouseSetVert(1, (25 - LRd%))
   '***
   MButtons$ = "L  "
   DO WHILE (MButtons$ = "L  ")
	  CALL MouseStatus(Row%, col%, MButtons$)
	  Uprow% = Row%
	  Ltcol% = col%
	  Lorow% = Row% + LRd% - 1
	  Rtcol% = RCd% + col% - 1
	  WAIT &H3DA, 8
	  DEF SEG = VidSeg%
	  CALL RestScrn(ScrA%())
	  CALL DrawBox(Uprow%, Ltcol%, Lorow%, Rtcol%, 31, 2, 16, Shade%)
   LOOP
   CALL MouseSetHorz(1, 80)
   CALL MouseSetVert(1, 25)
END SUB

'******
SUB BoxReSize (Uprow%, Ltcol%, Row%, col%, Shade%)
   CALL MouseSetHorz(Ltcol% + 13, 78)
   CALL MouseSetVert(Uprow% + 3, 24)
   
   Lorow% = Row%: Rtcol% = col%
   MButtons$ = "  R"
   DO WHILE (MButtons$ = "  R")
	  WAIT &H3DA, 8
	  CALL RestScrn(ScrA%())
	  DEF SEG = VidSeg%
	  CALL DrawBox(Uprow%, Ltcol%, Lorow%, Rtcol%, 31, 2, 16, Shade%)
	  Lorow% = Row%: Rtcol% = col%
	  CALL MouseStatus(Row%, col%, MButtons$)
   LOOP
   CALL MouseSetHorz(1, 80)
   CALL MouseSetVert(1, 25)
END SUB

SUB HOLD
END SUB

'******
FUNCTION MouseInstalled%
   DEF SEG = 0
   MouseSeg& = 256& * PEEK(207) + PEEK(206)
   MouseOfs& = 256& * PEEK(205) + PEEK(204) + 2
   DEF SEG = MouseSeg&
   IF (MouseSeg& = 0 AND MouseOfs& = 0) OR PEEK(MouseOfs&) = 207 THEN
	  MouseInstalled% = 0
	  EXIT FUNCTION
   ELSE
	  MouseInstalled% = -1
   END IF
   DEF SEG
   RegX.ax = 0
   CALL InterruptX(&H33, RegX, RegX)
   IF RegX.ax = -1 THEN
	  MouseInstalled% = -1
   ELSE
	  MouseInstalled% = 0
   END IF
END FUNCTION

'******
SUB MouseLocate (Xpos%, Ypos%)
   RegX.dx = (Xpos% * 8) - 1
   RegX.cx = (Ypos% * 8) - 1
   RegX.ax = 4
   CALL InterruptX(&H33, RegX, RegX)
END SUB

'******
SUB MouseOff
   RegX.ax = 2
   CALL InterruptX(&H33, RegX, RegX)
END SUB

'******
SUB MouseOn
   RegX.ax = 1
   CALL InterruptX(&H33, RegX, RegX)
END SUB

'******
SUB MouseSetHorz (Min%, Max%)
   RegX.cx = (Min% * 8) - 1
   RegX.dx = (Max% * 8) - 1
   RegX.ax = 7
   CALL InterruptX(&H33, RegX, RegX)
END SUB

'******
SUB MouseSetVert (Min%, Max%)
   RegX.cx = (Min% * 8) - 1
   RegX.dx = (Max% * 8) - 1
   RegX.ax = 8
   CALL InterruptX(&H33, RegX, RegX)
END SUB

'******
SUB MouseStatus (Vert%, Hor%, MButtons$)
   RegX.ax = 3
   CALL InterruptX(&H33, RegX, RegX)
   Vert% = (RegX.dx / 8) + 1
   Hor% = (RegX.cx / 8) + 1
   SELECT CASE RegX.bx
	  CASE 0: MButtons$ = "   "
	  CASE 1: MButtons$ = "L  "
	  CASE 2: MButtons$ = "  R"
	  CASE 3: MButtons$ = "L R"
	  CASE 4: MButtons$ = " C "
   END SELECT
END SUB

'******
SUB RestScrn (Scr%())
   '*** you calc'ed the video segment every time here and in
   '*** SaveScrn too. I made it a global variable instead.
' (is it faster???)
   destoff = 0
   fromseg = VARSEG(Scr%(0))
   fromoff = VARPTR(Scr%(0))
   nbytes = 4000
   MemCopy fromseg, fromoff, VidSeg%, destoff, nbytes
END SUB

'******
SUB SaveScrn (Scr%())
   fromoff = 0
   destseg = VARSEG(Scr(0))
   destoff = VARPTR(Scr(0))
   nbytes = 4000
   MemCopy VidSeg%, fromoff, destseg, destoff, nbytes
END SUB

