DEFINT A-Z
'$INCLUDE: 'kyb.bi'
'$INCLUDE: 'neptune.bi'
DECLARE FUNCTION GetMMode%                '0 = Fore, 255 = Back
DECLARE FUNCTION GetNoteLength%           'in 1,000ths/second (?)
DECLARE FUNCTION GetOctave%               '0 to 6
DECLARE FUNCTION GetScale%                '1=Legato, 2=Staccato, 3=Normal
DECLARE FUNCTION GetTempo%                '32 to 255
DECLARE FUNCTION NumNotes%                'same as PLAY(n) function?

DECLARE SUB SetMMode (BYVAL Mode%)        'same as "MF"/"MB"
DECLARE SUB SetNoteLength (BYVAL Length%) 'dynamically alter note length
DECLARE SUB SetOctave (BYVAL Octave%)     'same as "On"
DECLARE SUB SetScale (BYVAL Scale%)       'same as "MN"/"ML"/"MS"
DECLARE SUB SetTempo (BYVAL Tempo%)       'Same as "Tn"

CLS
'Set up the music parameters...
'The following 4 calls are the same as:  PLAY "MB O2 MN T180"
CALL SetMMode(255)                        'Background mode
CALL SetOctave(2)                         '2nd octave
CALL SetScale(3)                          'Normal scale
CALL SetTempo(180)                        '180 quarternotes/second

music$ = "L1 GGG E-.... FFF D....>GGG E- FFF D <GGG"
PLAY music$                               'start the music

PRINT "Tempo:"; GetTempo%
PRINT "Octave:"; GetOctave%
PRINT "Scale:"; GetScale%
PRINT "Notes left to play:"
PRINT "Countdown to next note:"
DO
  Notes = NumNotes%                       '# of notes to go
  LOCATE 4, 20: PRINT Notes
  LOCATE 5, 24: PRINT GetNoteLength%
  'Truncate the current note when a key is pressed
  IF LEN(INKEY$) THEN CALL SetNoteLength(Zero)
LOOP WHILE Notes                          'exit when all have played

