' 
' NETSTUFF.BAS  1-10-94  Matt Hart
' 

    '$DYNAMIC
    DEFINT A-Z

    TYPE RegTypeX                       ' Interrupt call structure
        AX    AS INTEGER
        BX    AS INTEGER
        CX    AS INTEGER
        DX    AS INTEGER
        BP    AS INTEGER
        SI    AS INTEGER
        DI    AS INTEGER
        Flags AS INTEGER
        DS    AS INTEGER
        ES    AS INTEGER
    END TYPE

    TYPE Request                        ' Novell connection control
        ReqLen      AS INTEGER          ' request buffer
        Opt         AS STRING * 1
        Dat         AS STRING * 157
    END TYPE

    TYPE Reply                          ' Novell connection control
        RepLen      AS INTEGER          ' reply buffer
        Dat         AS STRING * 128
    END TYPE

    DIM InReg AS RegTypeX
    DIM OutReg AS RegTypeX

'------------------------- Get Connection ID first
    InReg.AX = &HDC00                       ' Get this station's connection
    CALL InterruptX(&H21, InReg, OutReg)    ' ID - returned in AL
    ConnID = OutReg.AX AND &HFF
'------------------------------------------------

    DIM Req AS Request
    DIM Rep AS Reply

'----------------------------------------------- USER NAME
'---------------------------------------------------------
'----------------------- Set request buffer info
    Req.ReqLen = 158
    Req.Opt = CHR$(&H16)                    ' Get conn info sub function
    Req.Dat = CHR$(ConnID)
'-----------------------------------------------

'---------------------- Set reply buffer length
    Rep.RepLen = 128
'----------------------------------------------

'---------------------- Set interrupt call stuff
    InReg.AX = &HE300                       ' Connection control function
    InReg.DS = VARSEG(Req)                  ' Address of request and reply
    InReg.SI = VARPTR(Req)                  ' buffers
    InReg.ES = VARSEG(Rep)
    InReg.DI = VARPTR(Rep)
'----------------------------------------------  Here we GO!
    CALL InterruptX(&H21, InReg, OutReg)

    Ecode = OutReg.AX AND &HFF

    IF Ecode = 0 THEN
        ObjName$ = MID$(Rep.Dat,7,48)+CHR$(0)
        ObjName$ = LEFT$(ObjName$,INSTR(ObjName$,CHR$(0)))
        ObjID$ = MID$(Rep.Dat,1,4)
        ObjType$ = MID$(Rep.Dat,5,2)
        PRINT "Login name = ";ObjName$
    ELSE
        PRINT "Ecode = ";Ecode
        END
    ENDIF
'------------------------------------------------------------

'--------------------------- Now for the hard part.  You must loop through
'--------------------------- all groups and test if the ID is in that group
    DIM ReqCheck AS Request
    DIM RepCheck AS Reply
    DIM InRegCheck AS RegTypeX
    DIM OutRegCheck AS RegTypeX

    ReqCheck.ReqLen = LEN(ReqCheck)-2
    ReqCheck.Opt = CHR$(&H43)
    RepCheck.RepLen = LEN(RepCheck)-2

    InRegCheck.AX = &HE300
    InRegCheck.DS = VARSEG(ReqCheck)
    InRegCheck.SI = VARPTR(ReqCheck)
    InRegCheck.ES = VARSEG(RepCheck)
    InRegCheck.DI = VARPTR(RepCheck)

    Req.Opt = CHR$(&H37)
    Req.Dat = STRING$(4,255) + CHR$(0)+CHR$(2) + CHR$(2) + "*"+CHR$(0)
    '       Scan Object ID  +  Scan Object Type  +  Name Len  +  Name

    CALL InterruptX(&H21, InReg, OutReg)
    Ecode = OutReg.AX AND &HFF
    DO UNTIL Ecode
        GroupName$ = MID$(Rep.Dat,7,48)+CHR$(0)
        GroupName$ = LEFT$(GroupName$,INSTR(GroupName$,CHR$(0)))
        GroupObjID$ = MID$(Rep.Dat,1,4)

        ReqCheck.Dat = CHR$(0)+CHR$(2) + CHR$(LEN(GroupName$)) + GroupName$ +_
                       CHR$(14) + "GROUP_MEMBERS"+CHR$(0) + ObjType$ +_
                       CHR$(LEN(ObjName$)) + ObjName$
        ' Scan Object Type + Scan Name Length + Scan Name +_
        ' Property Name Length + Property Name + Object Type +_
        ' Object Name Length + Object Name
        CALL InterruptX(&H21, InRegCheck, OutRegCheck)
        ReturnCode = OutRegCheck.AX AND &HFF
        IF ReturnCode = 0 THEN PRINT "Member of ";GroupName$

        MID$(Req.Dat,1,4) = GroupObjID$
        CALL InterruptX(&H21, InReg, OutReg)
        Ecode = OutReg.AX AND &HFF
    LOOP
