; PRINTMEM.ASM  Matt Hart
;
; Place the contents of memory into a string.
; DECLARE SUB PrintMem(Strg$, BYVAL Segment%, BYVAL Offset%)
;
; Set Strg$ = SPACE$(NumBytesToRead)

.MODEL MEDIUM,BASIC
.CODE

PrintMem PROC USES DS ES SI DI, Strg:Word, SegNum:Word, OffNum:Word
    MOV     AX,SegNum       ; Segment into AX
    MOV     SI,OffNum       ; Offset into SI

    MOV     BX,Strg         ; Addr of Strg Descriptor into BX
    MOV     DI,[BX+2]       ; Addr of Strg's first byte into DI
    MOV     CX,[BX]         ; Length of Strg into CX

    MOV     DX,DS           ; DS into DX - can't do MOV ES,DS directly
    MOV     ES,DX           ; ES:DI is now destination
    MOV     DS,AX           ; DS:SI is now source, CX has num bytes

    REP     MOVSB           ; Move DS:SI into ES:DI for CX times

    RET                     ; Back to BASIC
PrintMem ENDP
END
