BDSeg   segment at 40h          ;-this is the location of the
                                ;Bios Data Segment (BDSeg).
        org     72h             ;-take us to an offset 72h
                                ;from the beginning of BDSeg
FLAG    dw      ?               ;-we set this memory location
                                ;to 1234h if we want a warm
                                ;boot. Any other value for a
                                ;cold boot.
BDSeg   ends                    ;-signifies end of this segment

BOOTSeg segment at 0FFFFh       ;-segment close to end of physical
                                ;memory
BOOTLOC:                        ;-this is where to jump to
BOOTSeg ends

CSeg    segment 'code'          ;-beginning of our code segment
        org     100h            ;-required for *.com file
start:
        mov     ax, BDSeg
        mov     ds, ax          ;-set DS to segment of BDSeg
        assume CS:CSeg, DS:BDSeg
        mov     [FLAG], 1234h   ;-put the value of 1234h into
                                ;memory location occupied by
                                ;FLAG for a warm boot. For
                                ;cold boot put any other value in
                                ;suggested value is 0000h
        jmp far ptr BOOTLOC     ;-now jump to this memory location
CSeg    ends
        end     start
