            ; handle by Steve Gartrell           
            .model medium, basic

            .code




handle  PROC

    push    bp                      ; set up stack frame ptr
    mov     bp, sp
    push    ax
    push    bx
    push    dx
    push    si
    mov     bx, [bp + 6]            ;get ptr to start of this handler
                                    ; (stored in DGROUP)
    mov     bx, [bx]

    mov     ax, [bp + 2]            ; get QB sub return offset
    add     ax, 03h                 ; add 3 to compensate for
                                    ;  JMP opcode
    mov     WORD PTR [bx + 65h], ax ; store in code
    mov     ax, [bp + 4]            ; get QB sub return seg
    mov     WORD PTR [bx + 61h], ax ; store in code

    mov     ax, bx                  ;get Alldone start offset
    add     ax, 69h
    mov     WORD PTR [bx + 5Dh], ax ; store in code

    mov     si, bx                  ;preserve start of code ptr

    add     bx, 4Eh                 ;calculate the offset of the
    mov     ax, bx                  ; IntEntry label as the new
                                    ; interrupt handler vector
    mov     bx, [bp + 8]
    mov     dx, WORD PTR [bx]       ;original int offset to DX
    mov     WORD PTR [si + 7Ch], dx ; and moved to code storage
    mov     WORD PTR [bx], ax       ;new offset returned to QB

    mov     bx, [bp + 0Ah]
    mov     dx, WORD PTR [bx]       ;original int segment to DX
    mov     WORD PTR [si + 7Eh], dx ; and moved to code storage
    mov     WORD PTR [bx], cs       ;new segment returned to QB

    mov     ax, si                  ;start of code ptr in AX
    add     ax, 7Ch                 ;add distance to offset of OldInt
    mov     [si + 76h], ax          ;move to actual JMP opcode

    pop     si
    pop     dx
    pop     bx
    pop     ax
    pop     bp
    retf    6


IntEntry:

    push    bp                      ; push everything
    pushf
    push    ax
    push    bx
    push    cx
    push    dx
    push    es
    push    ds
    push    di
    push    si
    push    ss                      ;cuz the damned data seg gets lost
    pop     ds
    sti
    push    cs
    mov     ax, 9090h               ;[bx + 5Dh]  Here the POP
    push    ax                      ; portion of the DGROUP Asm
                                    ; opcodes is placed on the
                                    ; stack for the QB routine to
                                    ; Call Absolute to a RETF...
HandSeg:
    mov     ax, 9090h               ;[bx + 61h]  Here the QB sub segment
    push    ax                      ; is placed on the stack for the
                                    ; (Cheating!) RETF
HandOff:
    mov     ax, 9090h               ;[bx + 65h]  Here the QB sub offset
    push    ax                      ; is placed on the stack for the
                                    ; (Cheating!) RETF
    retf
AllDone:
    pop     si                      ; pop everything
    pop     di
    pop     ds
    pop     es
    pop     dx
    pop     cx
    pop     bx
    pop     ax
    popf
    pop     bp
    jmp     cs:OldInt               ;[si + 74h]

    add     sp, 10
    retf                            ;roll the stack ptr back past the
                                    ; last CALL Absolute far return
                                    ; address and the three dummy
                                    ; variables on the stack.  This
                                    ; leaves the far return address
                                    ; to AllDone next on the stack...

OldInt  DD      90909090h           ;[si + 7Ch][si + 7Eh]

handle  ENDP

    END
