' 3D points by Tom Berggren with help from Rich Geldreichs' VECT.ASM
' Plots a set of 3D data points to screen 13. Data table has the following
' form;
' (No.points-1)*3, x0, y0, z0, x1, y1, z1, ....., xn, yn, zn
' Data should be within range of (-100,-100,-100)--->(100,100,100)
' keys to use; "v" resets, "c" stops, arrows, PgUp, PgDn, Esc.
' before running this program you need to do the following
' create threed.lib with, LIB threed+threed;
' create threed.qlb with, LINK threed.lib/qu,,nul,c:\qb45\lib\bqlb45;
' run with QB /l threed

DEFINT A-Z
DECLARE SUB Points (Pts%(), no.pts%)
DECLARE SUB ThreeD (BYVAL segm%, BYVAL offset%, BYVAL no.pts%)
RESTORE
DIM Pts%(600)

Points Pts%(), No.Points%

ThreeD VARSEG(Pts%(0)), VARPTR(Pts%(0)), (No.Points% + 1) \ 3

CLS
COLOR 9
LOCATE 5, 30: PRINT "By Tom Berggren"
LOCATE 6, 31: PRINT "January 1994"
COLOR 7
END

' "QB45" Data Follows; 503= (No.points-1)*3
DATA  503 
DATA  -48,   8,  -4, -48,   8,   0, -48,   8,   4, -44,   8,  -4
DATA  -44,   8,   0, -44,   8,   4, -40,   8,  -4, -40,   8,   0
DATA  -40,   8,   4, -52,   4,  -4, -52,   4,   0, -52,   4,   4
DATA  -36,   4,  -4, -36,   4,   0, -36,   4,   4, -52,   0,  -4
DATA  -52,   0,   0, -52,   0,   4, -36,   0,  -4, -36,   0,   0
DATA  -36,   0,   4, -52,  -4,  -4, -52,  -4,   0, -52,  -4,   4
DATA  -40,  -4,  -4, -40,  -4,   0, -40,  -4,   4, -36,  -4,  -4
DATA  -36,  -4,   0, -36,  -4,   4, -48,  -8,  -4, -48,  -8,   0
DATA  -48,  -8,   4, -44,  -8,  -4, -44,  -8,   0, -44,  -8,   4
DATA  -40,  -8,  -4, -40,  -8,   0, -40,  -8,   4, -36,  -8,  -4
DATA  -36,  -8,   0, -36,  -8,   4, -30,   8,  -4, -30,   8,   0
DATA  -30,   8,   4, -26,   8,  -4, -26,   8,   0, -26,   8,   4
DATA  -22,   8,  -4, -22,   8,   0, -22,   8,   4, -18,   8,  -4
DATA  -18,   8,   0, -18,   8,   4, -30,   4,  -4, -30,   4,   0
DATA  -30,   4,   4, -14,   4,  -4, -14,   4,   0, -14,   4,   4
DATA  -30,   0,  -4, -30,   0,   0, -30,   0,   4, -26,   0,  -4
DATA  -26,   0,   0, -26,   0,   4, -22,   0,  -4, -22,   0,   0
DATA  -22,   0,   4, -18,   0,  -4, -18,   0,   0, -18,   0,   4
DATA  -30,  -4,  -4, -30,  -4,   0, -30,  -4,   4, -14,  -4,  -4
DATA  -14,  -4,   0, -14,  -4,   4, -30,  -8,  -4, -30,  -8,   0
DATA  -30,  -8,   4, -26,  -8,  -4, -26,  -8,   0, -26,  -8,   4
DATA  -22,  -8,  -4, -22,  -8,   0, -22,  -8,   4, -18,  -8,  -4
DATA  -18,  -8,   0, -18,  -8,   4,   4,   8,  -4,   4,   8,   0
DATA    4,   8,   4,   0,   4,  -4,   0,   4,   0,   0,   4,   4
DATA    4,   4,  -4,   4,   4,   0,   4,   4,   4,  -4,   0,  -4
DATA   -4,   0,   0,  -4,   0,   4,   4,   0,  -4,   4,   0,   0
DATA    4,   0,   4,  -8,  -4,  -4,  -8,  -4,   0,  -8,  -4,   4
DATA   -4,  -4,  -4,  -4,  -4,   0,  -4,  -4,   4,   0,  -4,  -4
DATA    0,  -4,   0,   0,  -4,   4,   4,  -4,  -4,   4,  -4,   0
DATA    4,  -4,   4,   8,  -4,  -4,   8,  -4,   0,   8,  -4,   4
DATA    4,  -8,  -4,   4,  -8,   0,   4,  -8,   4,  14,   8,  -4
DATA   14,   8,   0,  14,   8,   4,  18,   8,  -4,  18,   8,   0
DATA   18,   8,   4,  22,   8,  -4,  22,   8,   0,  22,   8,   4
DATA   26,   8,  -4,  26,   8,   0,  26,   8,   4,  30,   8,  -4
DATA   30,   8,   0,  30,   8,   4,  14,   4,  -4,  14,   4,   0
DATA   14,   4,   4,  14,   0,  -4,  14,   0,   0,  14,   0,   4
DATA   18,   0,  -4,  18,   0,   0,  18,   0,   4,  22,   0,  -4
DATA   22,   0,   0,  22,   0,   4,  26,   0,  -4,  26,   0,   0
DATA   26,   0,   4,  30,  -4,  -4,  30,  -4,   0,  30,  -4,   4
DATA   14,  -8,  -4,  14,  -8,   0,  14,  -8,   4,  18,  -8,  -4
DATA   18,  -8,   0,  18,  -8,   4,  22,  -8,  -4,  22,  -8,   0
DATA   22,  -8,   4,  26,  -8,  -4,  26,  -8,   0,  26,  -8,   4

DEFSNG A-Z
SUB Points (Pts%(), no.pts%)
DIM rx!(600)
READ no.pts%                  'Really = (number of points - 1) * 3
                              'for each x, y, z
FOR i% = 0 TO no.pts%         'Get each point x(i), y(i+1), z(i+2)
  READ rx!(i%)
  Pts%(i%) = rx!(i%) * 2      'Adjusts the size of point data.
PRINT Pts%(i%)                'Show data being read
NEXT i%
END SUB

