'     XMAS.BAS - requires .SNG file in the current directory
DECLARE SUB DisplayDays ()
DECLARE SUB DoThings ()
DECLARE SUB LoadSong ()
DECLARE SUB Calcdays ()
DIM SHARED DaysLeft
DIM SHARED Today$
DIM SHARED ThisDate$
DIM SHARED SongFile$
DIM SHARED SongName$
DIM SHARED music$(100)
DIM SHARED Text$
DIM SHARED LenText
DIM SHARED Measures
DIM SHARED LineNo
DIM SHARED StartTime
DIM SHARED EstDuration
DIM SHARED row(25), col(37), pixels(43)

FOR i = 1 TO 25: READ row(i): NEXT i      ' set up arrays for screen "snow"
FOR i = 1 TO 37: READ col(i): NEXT i
FOR i = 1 TO 42: READ pixels(i): NEXT i
ThisDate$ = DATE$

IF COMMAND$ <> "" THEN                    ' can pass a date (mm-dd-yyyy) or
      IF COMMAND$ > "@" THEN              ' a .sng file for testing purposes
            SongFile$ = COMMAND$
      ELSE
            ThisDate$ = COMMAND$
      END IF
END IF

CALL Calcdays
CALL LoadSong

SCREEN 1: PALETTE 0, 1: CLS               ' set up static part of screen
LOCATE 1, 1: PRINT STRING$(40, 240);
LOCATE 1, (40 - LEN(Today$)) / 2: PRINT Today$;
LOCATE 21, 1: PRINT STRING$(40, 240);
LOCATE 21, (40 - LEN(SongName$)) / 2: PRINT SongName$;

ON PLAY(1) GOSUB MusicTrap                ' set up background music
PLAY ON
PLAY "MB"
LineNo = 0                                ' LineNo of file (for timing)
StartTime = TIMER                         ' capture start time (for timing)
GOSUB MusicTrap

CALL DoThings                             ' main action occurs here
CALL DisplayDays                          ' days left displayed after song
SCREEN 0                                  ' restore screen and done!
END

MusicTrap:                                ' ON PLAY event puts us here
      IF LineNo > Measures THEN           ' whenever we need a few more
            RETURN                        ' notes to play...
      END IF
      LineNo = LineNo + 1
      PLAY music$(LineNo)
RETURN
'25 rows:
DATA 4, 18, 19, 13, 7, 6, 4, 12, 3, 15
DATA 9, 14, 10, 19, 5, 9, 8, 11, 16, 17
DATA 7, 4, 16, 10, 3
'37 cols:
DATA 18, 12, 34, 5, 28, 19, 3, 10, 38, 8
DATA 14, 25, 23, 33, 4, 30, 24, 16, 39, 7
DATA 21, 17, 6, 2, 20, 27, 36, 1, 37, 9
DATA 26, 28, 15, 22, 24, 11, 13
'43 pixels:
DATA 15, 42, 43, 15, 42, 248, 15, 42, 32, 32
DATA 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32
DATA 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32
DATA 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32,32

SUB Calcdays                          ' calc number of days until xmas
      Day$ = MID$(ThisDate$, 4, 2)
      Year$ = RIGHT$(ThisDate$, 4)
      Month = VAL(LEFT$(ThisDate$, 2))
      Day = VAL(Day$)
      Year = VAL(Year$)
      SELECT CASE Month
            CASE IS = 1: Julian = 0: Month$ = "January"
            CASE IS = 2: Julian = 31: Month$ = "February"
            CASE IS = 3: Julian = 59: Month$ = "March"
            CASE IS = 4: Julian = 90: Month$ = "April"
            CASE IS = 5: Julian = 120: Month$ = "May"
            CASE IS = 6: Julian = 151: Month$ = "June"
            CASE IS = 7: Julian = 181: Month$ = "July"
            CASE IS = 8: Julian = 212: Month$ = "August"
            CASE IS = 9: Julian = 243: Month$ = "September"
            CASE IS = 10: Julian = 273: Month$ = "October"
            CASE IS = 11: Julian = 304: Month$ = "November"
            CASE IS = 12: Julian = 334: Month$ = "December"
      END SELECT
      Today$ = " " + Month$ + " " + Day$ + ", " + Year$ + " "
      Julian = Julian + Day

      IF Year MOD 4 = 0 AND Month > 2 THEN
            Julian = Julian + 1
            XMAS = 360 'leap year
      ELSE
            XMAS = 359
      END IF

      DaysLeft = XMAS - Julian
  
      IF DaysLeft < 0 THEN DaysLeft = DaysLeft + 365

END SUB

SUB DisplayDays
CLS
LOCATE 12, 1
IF DaysLeft = 1 THEN
      PRINT "There is ONE!!! sleep until Christmas!"
ELSE
      PRINT "There are"; DaysLeft; "sleeps until Christmas!"
END IF
VIEW PRINT
LOCATE 25, 1: PRINT "Press any key...";
DO: LOOP UNTIL INKEY$ <> ""

END SUB

SUB DoThings

i = 0: j = 0: k = 0: Pointer = 0: Counter = 0: Delay = 20
DIM Image(1 TO 4096) AS INTEGER

' main loop: put a snow character somewhere on the screen, and then
' update the ticker-tape on the bottom
DO
      i = i + 1: IF i > 24 THEN i = 1             ' i,j,k are intended to
      j = j + 1: IF j > 37 THEN j = 1             ' "randomize" the snow
      k = k + 1: IF k > 43 THEN k = 1             ' locations on the screen
      LOCATE row(i), col(j): PRINT CHR$(pixels(k));

' the program doesn't do a very good job of matching the music with the
' lyrics. Each pass through the loop, try to keep the lyrics at about the same
' spot as the music by adjusting the delay.

' EstDuration = (Measures * BeatsPerMeasure * 60) / Tempo
' LenText is the total # of characters in the lyrics. (These two values
' are calculated in LoadSong sub)

      IF Counter = 0 THEN
            Pointer = Pointer + 1
            LOCATE 23, 39: PRINT MID$(Text$, Pointer, 1); " ";
            GET (8, 176)-(311, 183), Image
            RelPosInText% = Pointer * 100 / LenText
            RelPosInMusic% = (TIMER - StartTime) / EstDuration * 100
            SELECT CASE RelPosInText% - RelPosInMusic%
               CASE IS < -5
                  Delay = Delay / 2
               CASE IS < -2
                  Delay = Delay - 2
               CASE IS < -1
                  Delay = Delay - 1
               CASE IS < 1
                  Delay = Delay
               CASE IS < 2
                  Delay = Delay + 1
               CASE ELSE
                  Delay = Delay + 2
            END SELECT
      ELSE
            PUT (8 - Counter, 176), Image, PSET
            FOR l = 1 TO Delay: NEXT l
      END IF
      Counter = Counter + 1
      IF Counter = 8 THEN Counter = 0
LOOP UNTIL LineNo > Measures

END SUB

SUB LoadSong
' check the current directory for songs, and pick one
' then load the song into Music$() and the lyrics into Text$
      DIM a$(30)
      IF SongFile$ = "" THEN
            SHELL "DIR *.SNG/B>DIR.LST"
            SHELL "SMARTDRV /C"
            OPEN "DIR.LST" FOR INPUT AS #1
            WHILE NOT EOF(1)
                  Songs = Songs + 1
                  LINE INPUT #1, a$(Songs)
            WEND
            CLOSE #1
            KILL "DIR.LST"

            SongFile$ = a$((DaysLeft MOD Songs) + 1)
      END IF
  
      OPEN SongFile$ FOR INPUT AS #1
      INPUT #1, SongName$
      INPUT #1, BeatsPerMeasure, Tempo
      SongName$ = " " + SongName$ + " "
      Measures = 0
      DO
         INPUT #1, X$
         IF X$ <> "##@" THEN
            Measures = Measures + 1
            music$(Measures) = X$
         END IF
      LOOP UNTIL X$ = "##@"

      WHILE NOT EOF(1)
            INPUT #1, X$
            Text$ = Text$ + X$
      WEND
      CLOSE #1
      Text$ = Text$ + SPACE$(20)
      LenText = LEN(Text$)
      EstDuration = (Measures * BeatsPerMeasure * 60) / Tempo
      a = a
END SUB
