DECLARE FUNCTION GetArchive$ (FileName$)
'$DYNAMIC

REM $STATIC
DEFINT A-Z
FUNCTION GetArchive$ (FileName$)
 
   'Returns the DOS command needed to un-archive the passed FileName$
   'The archiver information is from the COMPRESS.CFG included in
   'Scott Dudley's SquishMail message base utility.  Thanks Scott!

   Free = FREEFILE
   OPEN FileName$ FOR BINARY AS #Free

   DIM Ident AS STRING * 5       'We'll need the first five bytes of the file
   GET #Free, , Ident            'GET the first five bytes
 
   IF LEFT$(Ident, 1) = CHR$(26) THEN  'We know it's an ARC if the first
                                 'byte is an EOF.
      GetArchive$ = "arce "      'return the command to extract the ARC
   ELSEIF LEFT$(Ident, 4) = "PK" + CHR$(3) + CHR$(4) THEN
                                 'we know it's a zip if the first three bytes
      GetArchive$ = "PKUNZIP "   'are "PK^C^D".
   ELSEIF RIGHT$(Ident, 3) = "-lh" THEN
                                 'If the 3 bytes at offset 2
      GetArchive$ = "LHA E "     'are "-lh" then we know it's an LHA.
   ELSEIF LEFT$(Ident, 2) = CHR$(96) + CHR$(234) THEN
                                 'If the first 2 bytes of the file
      GetArchive$ = "ARJ E "     'are CHR$(96) and CHR$(234), it`s an ARJ.
   ELSE
      GetArchive$ = ""           'unknow archive type
   END IF
  
   CLOSE

END FUNCTION

DEFSNG A-Z
SUB Unarchive (FileName AS STRING)
   'un-archives a .QWK file
   UnpackProg$ = GetArchive$(FileName)
   SHELL UnpackProg$ + FileName
END SUB

