'**********************************************************
'***** Window Explodd, expand and shadow declarations *****
'**********************************************************
DEFINT A-Z
DECLARE SUB Drawbox (Uprow, Ltcol, Lorow, Rtcol)
DECLARE SUB HDivide (Hzrow, Ltcol, Rtcol)
DECLARE SUB VDivide (Uprow, Vtcol, Lorow)
DECLARE SUB Shadow (Uprow, Ltcol, Lorow, Rtcol)
DECLARE SUB Explodd (Uprow, Ltcol, Lorow, Rtcol)
DECLARE SUB Expand (Uprow, Ltcol, Lorow, Rtcol)
DECLARE SUB Lineout (LineColor)
DECLARE SUB Linein (LineColor)
DECLARE SUB Pause (ticks%)
'**********************************************************
'***** Window Explodd, expand and shadow end **************
'**********************************************************

	CLS
	Linein 1


	LOCATE 1, 1
	COLOR 7, 1
	FOR i = 1 TO 13
		FOR ch = 33 TO 176
			PRINT CHR$(ch);
		NEXT ch
	NEXT i


	COLOR 0, 3
	Explodd 3, 3, 10, 30

	COLOR 14, 4
	Expand 8, 12, 20, 45

	COLOR 0, 7
	Explodd 5, 40, 18, 75

	COLOR 14, 1
	Expand 10, 25, 15, 65

SUB Drawbox (Uprow, Ltcol, Lorow, Rtcol) STATIC
	Wide = (Rtcol - Ltcol) - 1
	LOCATE Uprow, Ltcol
	PRINT CHR$(201); STRING$(Wide, CHR$(205)); CHR$(187);
	FOR i = Uprow + 1 TO Lorow - 1
		LOCATE i, Ltcol
		PRINT CHR$(186); SPACE$(Wide); CHR$(186);
	NEXT i
	LOCATE Lorow, Ltcol
	PRINT CHR$(200); STRING$(Wide, CHR$(205)); CHR$(188);
END SUB

SUB Expand (Uprow, Ltcol, Lorow, Rtcol) STATIC
	RowCenter = ((Lorow - Uprow) / 2) + Uprow
	ColCenter = ((Rtcol - Ltcol) / 2) + Ltcol
	UprRow = RowCenter: LeftCol = ColCenter
	LwrRow = RowCenter: RghtCol = ColCenter
	DO
		LeftCol = LeftCol - 1
		RghtCol = RghtCol + 1
		IF LeftCol < Ltcol THEN LeftCol = Ltcol
		IF RghtCol > Rtcol THEN RghtCol = Rtcol
		Drawbox UprRow, LeftCol, LwrRow, RghtCol
		IF LeftCol = Ltcol AND RghtCol = Rtcol THEN EXIT DO
	LOOP
	DO
		UprRow = UprRow - 1
		LwrRow = LwrRow + 1
		IF UprRow < Uprow THEN UprRow = Uprow
		IF LwrRow >= Lorow THEN LwrRow = Lorow
		Drawbox UprRow, LeftCol, LwrRow, RghtCol
		IF UprRow = Uprow AND LwrRow = Lorow THEN EXIT DO
		Pause 1
	LOOP
	Shadow Uprow, Ltcol, Lorow, Rtcol
END SUB

SUB Explodd (Uprow, Ltcol, Lorow, Rtcol) STATIC
	RowCenter = ((Lorow - Uprow) / 2) + Uprow
	ColCenter = ((Rtcol - Ltcol) / 2) + Ltcol
	UprRow = RowCenter: LeftCol = ColCenter
	LwrRow = RowCenter: RghtCol = ColCenter
	DO
		UprRow = UprRow - 1
		LeftCol = LeftCol - 3
		LwrRow = LwrRow + 1
		RghtCol = RghtCol + 3
		IF UprRow < Uprow THEN UprRow = Uprow
		IF LeftCol < Ltcol THEN LeftCol = Ltcol
		IF LwrRow > Lorow THEN LwrRow = Lorow
		IF RghtCol > Rtcol THEN RghtCol = Rtcol
		Drawbox UprRow, LeftCol, LwrRow, RghtCol
		IF UprRow = Uprow AND LeftCol = Ltcol AND LwrRow = Lorow AND RghtCol = Rtcol THEN
			EXIT DO
		END IF
		Pause 1
	LOOP
	Shadow Uprow, Ltcol, Lorow, Rtcol
END SUB

SUB HDivide (Hzrow, Ltcol, Rtcol) STATIC
	length = Rtcol - Ltcol - 1
	LOCATE Hzrow, Ltcol
	PRINT ""; STRING$(length, ""); ""
END SUB

SUB Linein (LineColor) STATIC
	DIM Lines$(1 TO 23)
	Lines$(2) = SPACE$(39) + "" + SPACE$(2)
	Lines$(1) = SPACE$(39) + "." + SPACE$(2)
	Lines$(23) = STRING$(80, "")
	Sp = 39
	Ln = 0
	FOR i = 2 TO 21
		Lines$(i) = SPACE$(Sp) + STRING$(Ln, "") + SPACE$(2)
		Sp = Sp - 2
		Ln = Ln + 4
	NEXT i
  
	COLOR LineColor, 0
	FOR i = 1 TO 23
		LOCATE 13, 1
		PRINT Lines$(i);
		CALL Delay18th(1)
	NEXT

	COLOR 0, LineColor
	x = 12
	y = 13
	FOR i = 1 TO 12
		LOCATE y, 1
		PRINT STRING$(80, " ");
		LOCATE x, 1
		PRINT STRING$(80, " ");
		CALL Delay18th(1)
		x = x - 1
		y = y + 1
	NEXT i
END SUB

SUB Lineout (LineColor) STATIC
	DIM Lines$(1 TO 23)
	Lines$(1) = STRING$(80, "")
	Sp = 2
	Ln = 76
	FOR i = 2 TO 21
		Lines$(i) = SPACE$(Sp) + STRING$(Ln, "") + SPACE$(2)
		Sp = Sp + 2
		Ln = Ln - 4
	NEXT i
	Lines$(22) = SPACE$(39) + "" + SPACE$(2)
	Lines$(23) = SPACE$(39) + "." + SPACE$(2)

	COLOR 0, 0
	x = 1
	y = 25
	FOR i = 1 TO 12
		LOCATE y, 1
		PRINT STRING$(80, CHR$(32));
		LOCATE x, 1
		PRINT STRING$(80, CHR$(32));
		CALL Delay18th(1)
		x = x + 1
		y = y - 1
	NEXT i
	COLOR LineColor, 0
	FOR i = 1 TO 23
		LOCATE 13, 1
		PRINT Lines$(i);
		CALL Delay18th(1)
	NEXT
	COLOR 7
	CLS
	EXIT SUB
END SUB

SUB Pause (ticks%)
	DEF SEG = 0
	DO UNTIL TestTick% > ticks%
		LastTick% = GetTick%        'Compare this to adjust count.
		GetTick% = PEEK(&H46C)      'Get a tick from the clock.
		'...Prevent endless loop when rolling past midnight.
		IF LastTick% <> GetTick% THEN TestTick% = TestTick% + 1
	LOOP
	'...back to normal
	DEF SEG
END SUB

SUB Shadow (Uprow, Ltcol, Lorow, Rtcol) STATIC
	DEF SEG = &H40
	equip = PEEK(&H10)
	IF (equip AND 48) = 48 THEN
		EXIT SUB    '*** no use in doing it if it's monochrome, right?
	ELSE
		DEF SEG = &HB800
	END IF

'*********************************************************
'****** find out what the screen attribute  **************
'****** already is (underneath the box) ******************
'*********************************************************


	attr = SCREEN(Lorow + 1, Rtcol + 1, -1)  ' Obtain the color attribute
	attr = attr AND 15                       ' Calculate forground color.
	attr = attr - 8                          ' Remove bright from the color
	IF attr < 1 THEN attr = 8                ' In case color wasn't bright

'*********************************************************
'****** use the given box dimensions to POKE a ***********
'****** "shadow" on the right side and bottom edge *******
'*********************************************************


	FOR row = Uprow + 1 TO Lorow + 1       '***** right edge locations. ***
		FOR Col = Rtcol + 1 TO Rtcol + 2   '***** make it 2 chars wide. ***
			offset = (row - 1) * 160 + (Col - 1) * 2 + 1
			POKE offset, attr
		NEXT
	NEXT

	row = Lorow + 1                        '***** now POKE along the ******
	FOR Col = Ltcol + 2 TO Rtcol + 2       '***** bottom edge *************
		offset = (row - 1) * 160 + (Col - 1) * 2 + 1
		POKE offset, attr
	NEXT
	DEF SEG

END SUB

SUB VDivide (Uprow, Vtcol, Lorow) STATIC
	length = Lorow - Uprow - 1
	LOCATE Uprow, Vtcol
	PRINT "";
	FOR i = Uprow + 1 TO Lorow - 1
		LOCATE i, Vtcol
		PRINT ""'
	NEXT i
	LOCATE , Vtcol
	PRINT "";
END SUB

