
REM   Test code for demonstrating BufInput$, et.al.

DECLARE FUNCTION BufInput$ (FileHandle%)
DECLARE FUNCTION BufEOF% ()
DECLARE FUNCTION BufError% ()
DECLARE SUB BufSetSize (BytesInBuffer%)

 CLS
 LINE INPUT "Name of file to read (buffered):"; FileName$

 FileNum% = FREEFILE
 OPEN FileName$ FOR BINARY AS FileNum%
 Handle% = FILEATTR(FileNum%, 2)    'returns DOS file handle

 MemAvailable& = SETMEM(0)
 IF MemAvailable& < 32768 THEN
    NewSize% = CINT(MemAvailable&) - 32
    BufSetSize (NewSize%)
 END IF

 DO
   PRINT BufInput$(Handle%)
 LOOP UNTIL BufEOF% OR BufError%

 IF BufError% THEN
    'not too likely we read the whole file, is it?
    'oh well... maybe we should look into it!
 END IF

 CLOSE FileNum%
END
