' Simple chat encryptor, for use with Telix v3.15
' Version 1.0
' This is used primarily in MBBS Chat mode, so no one can
' see the conversation. (Unless of course he or she knows the code!)
' This prompts the user for a RANDOMIZE base, then uses that to compute a
' cryption alagorithm. Due to the BBS Chat's only using ASCII codes 32-126
' and not the others, this encryption is forced to be letter substitution.
' This writes a Translate Table.
' Just press Alt-W, before a chat, and load them accordingly. When the chat
' is done, just unload them. Of course, both users must have the same tables
' to read each other's 'writings'. (Well really, all they need to know is
' the same RANDOMIZEing numbers!)
' Please do not use this if the sysop dissapproves. ALL liability, and risk
' is taken by you. Don't come crying to me if you do something against the
' SysOps wishes and he or she throws you off the BBS!
' By Glenn Kinen, in the Public Domain.

DEFINT A-Z
DECLARE FUNCTION Rand (low, high)
DIM AsciiNumbers(32 TO 126) 'ASCii characters 32-126, 127 (Ctrl-Backspace) is ommited
CLS
OPEN "CHTCRYPT.TBL" FOR OUTPUT AS #1
PRINT "Glenn Kinen's Chat Crypt version 1.0"
PRINT "Herby released into the public domain!": PRINT

LINE INPUT "What number should I use as the encryption base? (-32768 TO 32767)  ", RndBas$
IF VAL(RndBas$) > 32767 OR VAL(RndBase$) < -32768 THEN PRINT "Overflow!": BEEP: END
RANDOMIZE VAL(RndBas$)

FOR i = 0 TO 31
 PRINT #1, RTRIM$(LTRIM$(STR$(i))); "="; RTRIM$(LTRIM$(STR$(i))) 'Define control charcters
 LOCATE 6: PRINT "On byte:"; i
NEXT i

FOR j = 32 TO 126
count% = count% + 1
TryAgain:
 randomNum = Rand(32, 127)
  FOR k = 32 TO count + 31
   IF randomNum = AsciiNumbers(k) THEN status = -1: EXIT FOR
  NEXT k
  IF status THEN
   GOTO TryAgain
  ELSE
    AsciiNumbers(j) = randomNum
    AsciiNumbers(randomNum) = j
  END IF
NEXT j

FOR m = 32 TO 126
 PRINT #1, AsciiNumbers(m)
NEXT

FUNCTION Rand (low, high)
 
  DO
   RandomNumber = INT(RND * high)
  LOOP UNTIL RandomNumber >= low

  Rand = RandomNumber
  EXIT FUNCTION

END FUNCTION

