        .model  medium,basic

        extrn   B_OnExit:proc

        .code

oldvec  dd      ?

txtmod  db      ?
txtcol  db      ?
txtloc  dw      ?
txtsep  dw      ?
clkcnt  dw      ?
clktic  db      ?
clksec  db      ?
clkmin  db      ?
clkhrs  db      ?

; DECLARE CLKINIT(mode%,locat%,col%,sep%,sepcol%)
;       mode% = Mode (0 for 24h, 1 for AM/PM)
;       locat% = location of text on the screen =line(0-24)*80+col(0-79) 
;       col% = color of text (0-255)
;       sep% = ASCII separator (usually 58 (:))
;       sepcol% = color of separator (0-255)
clkinit proc    mode,locat,col,sep,sepcol
        mov     bx,mode                 ; Get & store mode         
        mov     al,[bx]
        mov     txtmod,al
        mov     bx,locat                ; Get & store location 
        mov     ax,[bx]
        mov     txtloc,ax
        mov     bx,col                  ; Get & store color         
        mov     al,[bx]
        mov     txtcol,al
        mov     bx,sep                  ; Get & store separator 
        mov     al,[bx]
        mov     bx,sepcol
        mov     ah,[bx]
        mov     txtsep,ax
        push    ds
        push    es
        mov     ax,3508h                ; Get & Save old INT vector 
        int     21h
        mov     ax,es
        mov     cx,cs
        cmp     ax,cx
        jz      clk005
        mov     word ptr oldvec,bx
        mov     word ptr oldvec+2,ax
        mov     ah,2ch                  ; Get current time         
        int     21h
        mov     clkhrs,ch
        mov     clkmin,cl
        mov     clksec,dh
        mov     ax,2508h                ; Store new INT vector 
        push    cs
        pop     ds
        mov     dx,offset clock
        int     21h
        push    cs                      ; Call B_OnExit         
        mov     ax,offset clkstop
        push    ax
        call    B_OnExit
clk005: pop     es
        pop     ds
        ret
clock:  push    ax
        mov     al,clktic
        inc     al
        mov     clktic,al
        sub     al,18
        ja      @f
clk010: pop     ax
        jmp     oldvec
@@:     sub     clkcnt,10828
        mov     clktic,al
        mov     al,clksec
        inc     al
        mov     clksec,al
        sub     al,60
        jb      @f
        mov     clksec,al
        mov     al,clkmin
        inc     al
        mov     clkmin,al
        sub     al,60
        jb      @f
        mov     clkmin,al
        mov     clkmin,al
        mov     al,clkhrs
        inc     al
        mov     clkhrs,al
        sub     al,24
        jb      @f
        mov     clkhrs,al
@@:     push    di
        push    es
        int     11h
        and     al,30h
        cmp     al,30h
        mov     ax,0b000h
        jz      @f
        mov     ah,0b8h
@@:     mov     es,ax
        mov     di,txtloc
        cli
        mov     al,clkhrs       ; Display hh: (12/24h format) 
        mov     ah,al
        or      ah,ah
        jnz     @f
        add     ah,12
@@:     cmp     ah,13
        jb      @f
        sub     ah,12
@@:     cmp     txtmod,0
        jz      @f
        mov     al,ah
@@:     aam
        add     ax,3030h
        push    ax
        mov     al,ah
        mov     ah,txtcol
        stosw
        pop     ax
        mov     ah,txtcol
        stosw
        mov     ax,txtsep
        stosw
        mov     al,clkmin       ; Display mm:
        aam
        add     ax,3030h
        push    ax
        mov     al,ah
        mov     ah,txtcol
        stosw
        pop     ax
        mov     ah,txtcol
        stosw
        mov     ax,txtsep
        stosw
        mov     al,clksec       ; Display ss
        aam
        add     ax,3030h
        push    ax
        mov     al,ah
        mov     ah,txtcol
        stosw
        pop     ax
        mov     ah,txtcol
        stosw
        cmp     txtmod,0
        jnz     @f
clk020: pop     es
        pop     di
        jmp     clk010
@@:     mov     ah,txtcol
        mov     al,'a'
        cmp     clkhrs,12
        jb      @f
        mov     al,'p'
@@:     stosw
        mov     al,'m'
        stosw
        jmp     clk020
clkinit endp

clkstop proc
        push    ds
        mov     ax,2508h
        lds     dx,oldvec
        int     21h
        pop     ds
        ret
clkstop endp

        end
