1 ' COCO2IBM.BAS (C) 1990 by Steve Harmon
2 ' Converts tokenized Color Computer I and II BASIC programs to MSDOS GW-BASIC
3 ' ASCII files.  Note - Due to differences between CoCo BASIC and GW-BASIC,
4 ' this program can not do a complete conversion except to get the CoCo
5 ' program into a form that GW-BASIC can read so that it can then be edited.
6 '
10 CLEAR:KEY OFF:SCREEN 0,0,0:WIDTH 80:CLS
20 DIM LOTOKEN$(128),HITOKEN$(128),DIRFIL$(512):GOSUB 2020:GOTO 40
29 '----- Get a byte -----
30 IF EOF(1) THEN 2000 ELSE GET #1:BYTE$=CH$:BYTE=ASC(BYTE$):RETURN
39 '----- Get & display directory -----
40 SHELL"DIR "+PATH$+" /o /b >TEMP.$$$":NUMFIL=0:OPEN"TEMP.$$$" FOR INPUT AS #1:      WHILE NOT EOF(1):LINE INPUT #1,DIRFIL$(NUMFIL):NUMFIL=NUMFIL+1:WEND:CLOSE #1:   NUMFIL=NUMFIL-1:KILL"TEMP.$$$"
50 CLS:FOR T=0 TO NUMFIL:IF T<132 THEN LOCATE T MOD 20+2,(T\20)*13+1:PRINT DIRFIL$(T);
55 NEXT T
59 '----- Get filename and open -----
60 LOCATE 1,40:PRINT"Last file: ";SRCFIL$:LOCATE 1,1:LINE INPUT"Filename: ",SRCFIL$:IF SRCFIL$="" THEN CLS:STOP ELSE IF INSTR(SRCFIL$,".")=0 THEN SRCFIL$=SRCFIL$+".BAS" 'source filename
70 DESTFIL$=LEFT$(SRCFIL$,INSTR(SRCFIL$,".")-1)+".CC"  'destination filename
80 CLS
90 OPEN SRCFIL$ AS #1 LEN=1:FIELD #1,1 AS CH$:OPEN DESTFIL$ FOR OUTPUT AS #2
99 '----- Decoder loop -----
100 FOR T=1 TO 3:GOSUB 30:NEXT T 'skip over header at start of program
110 GOSUB 30:GOSUB 30 'skip over line link
120 GOSUB 30:HB=BYTE:GOSUB 30:LINNUM=HB*256+BYTE 'get line number
130 PRINT #2,MID$(STR$(LINNUM),2);" ";:PRINT MID$(STR$(LINNUM),2);" ";
140 GOSUB 30:IF BYTE=0 THEN PRINT #2,"":PRINT:GOTO 110
150 IF BYTE=255 THEN GOSUB 30:PRINT #2,HITOKEN$(BYTE-128);:PRINT HITOKEN$(BYTE-128);:GOTO 140
160 IF BYTE=26 THEN 2000
170 IF BYTE<128 THEN PRINT #2,CHR$(BYTE);:PRINT CHR$(BYTE);:GOTO 140
180 PRINT #2,LOTOKEN$(BYTE-128);:PRINT LOTOKEN$(BYTE-128);:GOTO 140
2000 CLOSE:PRINT STRING$(80,205):PRINT"[L]ist file, [K]ill output file, [Esc] to quit, or any other key...":BEEP
2002 I$=INKEY$:IF I$=CHR$(27) THEN STOP ELSE IF I$="L" OR I$="l" THEN SHELL"LIST "+DESTFIL$:GOTO 40 ELSE IF I$="K" OR I$="k" THEN KILL DESTFIL$:GOTO 2000 ELSE IF I$="" THEN 2002 ELSE 40
2010 '----- Initialize -----
2020 RESTORE 2020:READ LOSTART,LOEND,HISTART,HIEND:DATA 128,225,128,167
2021 RESTORE 2050:FOR T=LOSTART TO LOEND:READ LOTOKEN$(T-128):NEXT T
2022 RESTORE 2150:FOR T=HISTART TO HIEND:READ HITOKEN$(T-128):NEXT T
2030 'single-byte codes 128 to 225
2050 DATA "FOR ",GO,"REM ","'"," ELSE ","IF ","DATA ","PRINT ","ON ","INPUT "
2051 DATA "END ","NEXT ","DIM ","READ ","RUN ","RESTORE","RETURN","STOP"
2052 DATA "POKE ","CONT","LIST ","CLEAR ","NEW ","CLOAD ","CSAVE ","OPEN "
2053 DATA "CLOSE ","LLIST ","SET","RESET","CLS ","MOTOR ","SOUND ","AUDIO "
2054 DATA "EXEC ","SKIPF ","TAB(","TO ","SUB "," THEN ","NOT "," STEP ","OFF"
2055 DATA "+","-","*","/","^"," AND "," OR ",">","=","<","DEL ","EDIT "
2090 DATA "TRON","TROFF","DEF","LET ","LINE","PCLS ","PSET","PRESET","SCREEN "
2091 DATA "PCLEAR ","COLOR ","CIRCLE","PAINT","GET","PUT","DRAW","PCOPY "
2092 DATA "PMODE ","PLAY","DLOAD ","RENUM ","FN","USING ","DIR ","DRIVE "
2093 DATA "FIELD ","FILES ","KILL ","LOAD ","LSET ","MERGE ","RENAME ","RSET "
2094 DATA "SAVE ","WRITE "
2120 DATA VERIFY,UNLOAD,DSKINI,BACKUP,COPY,DSKI$,DSKO$,DOS
2130 'double-byte codes 255 + (128 to 167)
2150 DATA SGN,INT,ABS,USR,RND,SIN,PEEK,LEN,STR$,VAL,ASC,CHR$,EOF,JOYSTK,LEFT$
2160 DATA RIGHT$,MID$,POINT,INKEY$,MEM,ATN,COS,TAN,EXP,FIX,LOG,POS,SQR,HEX$
2170 DATA VARPTR,INSTR,TIMER,PPOINT,STRING$,CVN,FREE,LOC,LOF,MKN$," AS "
2180 RETURN

