; copro.asm, by Yousuf Kahn ( I hope he doesn't object to its
; use. )
.8087
%.model SMALL,c
;dosseg
;.stack 100h
.data
Bank    struc
        ;stacks
        s0      dw      0
        s1      dw      0
        s2      dw      0
        s3      dw      0
        s4      dw      0
        s5      dw      0
        s6      dw      0
        s7      dw      0
Bank    ends

b0      bank    <>      ;bank 0 storage
b1      bank    <>      ;bank 1 storage
cur_psp dw      0
;_data   ends
fsb0    macro           ;switch to bank 0
        db 0dbh, 0e8h
        endm
fsb1    macro           ;switch to bank 1
        db 0dbh, 0ebh
        endm
fsb2    macro           ;switch to bank 2
		db 0dbh, 0eah
        endm
f4x4    macro           ;do a 4x4 matrix transformation
        db 0dbh, 0f1h
        endm
Int_store       macro   b
                fistp   b.s0
                fistp   b.s1
                fistp   b.s2
                fistp   b.s3
                fistp   b.s4
                fistp   b.s5
                fistp   b.s6
                fistp   b.s7
                fwait
                endm
.code
iit_test        proc
                fsb0    ;bank 0
                ;fill in matrix with ones
				call    fill_matrix
                fsb1    ;bank 1
				call    fill_matrix
                int_store b0
                fsb0
                int_store b1
                finit
                mov     cx, 8
                mov     di, offset b0.s0
                mov     si, offset b1.s0
                cld
                repe    cmpsw
                sub     al,al
                or      cx, cx
                jnz     exit
                inc     al
exit:
                fclex
                finit
                ret
iit_test        endp


fill_matrix     proc    near
                mov     cx, 8
                finit
@l1:            fld1
                loop    @l1
                fwait
                ret
fill_matrix     endp

                end
