/* cpu.c: main module to put the assembly routines together and
 * report their results...
 */

#include <stdio.h>

int ndp_check(void);
int iit_test(void);
int cpu_check(void);

char *messages[] = {
    "No coprocessor installed.",
    "an Intel or Cyrix coprocessor.",
    "an IIT coprocessor."
};

int main(void) {

    int value=0;
    int cpu;

    printf("\nThis computer has an 80%d processor, and " ,cpu=cpu_check());
    if (ndp_check())
        value = iit_test() + 1;
    printf("%s\n",messages[value]);
    return (cpu / 100) * 10 + value;
}
