DEFINT A-Z

DECLARE SUB TransArray ()
DECLARE SUB CalcTables (sine(), cosi(), logi())
DECLARE SUB SaveImage ()
DECLARE SUB Mode13h ()
DECLARE SUB Mode03h ()
DECLARE SUB SetPalette ()
DECLARE SUB SetPalColour (Colour, Red, Green, Blue)
DECLARE SUB SetColor (x, y, Colour)

DIM sine(360)
DIM cosi(360)
DIM logi(360)

CalcTables sine(), cosi(), logi()
Mode13h
SetPalette
TransArray
SaveImage
Mode03h

END

SUB CalcTables (sine(), cosi(), logi())

PRINT
PRINT "This creates a little picture for use in my QB demo..."
PRINT "Calvin French 1993"
PRINT
PRINT "Please wait. I'm calculating some tables."
PRINT
YLoc = CSRLIN
PRINT STRING$(80, 176);

FOR n = 1 TO 360
  sine(n) = SIN(n / 57) * 1024
  cosi(n) = COS(n / 57) * 1024
  logi(n) = LOG(n / 57) * 1024
  LOCATE YLoc, 1
  PRINT STRING$(n / 360 * 80, 177);
NEXT n

END SUB

SUB Mode03h

SCREEN 0
WIDTH 80

END SUB

SUB Mode13h

SCREEN 13

END SUB

SUB SaveImage

DEF SEG = &HA000
BSAVE "SURPRISE.PIC", 0, 64000
DEF SEG

END SUB

SUB SetColor (x, y, Colour)

'DEF SEG = &HA000
'POKE (x + y * 320), Colour
'DEF SEG

PSET (x, y), Colour

END SUB

SUB SetPalColour (Colour, Red, Green, Blue)

OUT &H3C8, Colour
OUT &H3C9, Red
OUT &H3C9, Green
OUT &H3C9, Blue

END SUB

SUB SetPalette

FOR k = 0 TO 15 STEP 1
  FOR l = 0 TO 15 STEP 1
    SetPalColour k + 15 * l + 1, 4 * (k MOD 15), 4 * (l MOD 15), 63


'                        setpalcol(k+15*l+1,4*(k%15),4*(l%15),63);
'                        setpalcol(0,0,0,0);
  NEXT l
NEXT k

END SUB

SUB TransArray

SHARED sine()
SHARED cosi()
SHARED logi()

FOR d& = 1 TO 360
  FOR r = 1 TO 360
    z = logi(d&) \ 32
    IF z = 0 THEN z = 1
    x = 160 + (sine(r) * d&) \ 1024
    y = 100 + ((cosi(r) * d&) \ 1024 * 2) - z
    c = ((r * 2) MOD 15) + 15 * ((d& * 3) MOD 15) + 1
    LINE -(x, y), c
  NEXT
NEXT

END SUB

