'$INCLUDE: 'fido.bi'
'$DYNAMIC

DEFINT A-Z

DIM Ph AS FSC0039
DIM Pn AS FSC0045
DIM Mh AS MessageHeader
DIM B AS STRING * 1

OPEN "AC52E240.PKT" FOR BINARY AS #1
CLS

GET #1, , Ph

IF Ph.Version = 2 THEN
   IF Ph.Baud = 2 THEN
      PRINT "Packet uses FSC-0045 header."
      HeaderType = 2
      GET #1, 1, Pn
      Ph.origZone = Pn.origZone
      Ph.destZone = Pn.destZone
      Ph.origPoint = Pn.origPoint
      Ph.destPoint = Ph.destPoint
      LengthOfHeader = LEN(Pn)
   ELSEIF Ph.origZone AND Ph.destZone AND (QorigZone < 1 AND QdestZone < 1) THEN
      PRINT "Packet uses a FSC-0039 type packet header."
      LenthOfHeader = LEN(Ph)
   ELSE
      PRINT "Packet uses either a FTS-0001 or FSC-0039 header."
      Ph.origZone = Ph.QorigZone
      Ph.destZone = Ph.QdestZone
      LengthOfHeader = LEN(Ph)
  END IF
ELSE
   PRINT "Grunged packet."
   END
END IF

PRINT "Origin: "; Ph.origZone; ":"; Ph.origNet; "/"; Ph.OrigNode; "."; Ph.origPoint
PRINT "Dest:   "; Ph.destZone; ":"; Ph.destNet; "/"; Ph.destNode; "."; Ph.destPoint

WHILE NOT (EOF(1))
   GET #1, LOC(1), Mh
   PRINT "Header and Null String: "; Mh.Header; Mh.NullStr
   PRINT "Original Node: "; Mh.OrigNode
   PRINT "destination Node:  "; Mh.destNode
   PRINT "Original Net:  "; Mh.origNet
   PRINT "Destination Net:  "; Mh.destNet
   PRINT "Attributes:  "; Mh.Attributes
   PRINT "Cost:  "; Mh.Cost
   PRINT "Date/Time:  "; Mh.DateTime

   SLEEP
   k$ = INKEY$
  
   FOR a = 1 TO 5
      DO
         IF B <> CHR$(10) THEN
            PRINT B;
         END IF
         GET #1, , B
      LOOP UNTIL B = CHR$(0) OR B = CHR$(2)
      B = ""
      PRINT
   NEXT a
   SLEEP
   k$ = INKEY$
WEND

