DEFINT A-Z
DECLARE FUNCTION Exist2 (FIL$)
DECLARE FUNCTION ChangeFileExt$ (FileName$, NewExt$)
DECLARE SUB Logo ()

    Logo

    InFile$ = RTRIM$(COMMAND$)

    IF NOT Exist2(InFile$) THEN
        CALL Phwoop
        PRINT
        COLOR 4
        PRINT "Input file not specified or file not found"
        PRINT
        COLOR 7
        PRINT "Usage: filedata <filename>"
        END
    END IF

    OutFile$ = ChangeFileExt$(InFile$, "DAT")

    OPEN InFile$ FOR INPUT AS #1
    OPEN OutFile$ FOR OUTPUT AS #2

    PRINT
    PRINT "Working";
    COLOR 23
    PRINT ". . .";
    COLOR 7

    PRINT #2, "Filename"; SPACE$(8); "Size"; SPACE$(5); "File Date"; SPACE$(15); "Description"
    PRINT #2, STRING$(86, "=")
    DO WHILE NOT EOF(1)
        LINE INPUT #1, InLine$
        Pipe = INSTR(InLine$, "|")
        IF Pipe THEN
            FileName$ = RTRIM$(LEFT$(InLine$, Pipe - 1))
        END IF
        Desc$ = RTRIM$(MID$(InLine$, Pipe + 2, LEN(InLine$)))
        IF INSTR(FileName$, ".") <> 0 THEN
            Txt$ = FileName$ + "....." + Desc$ + " "
        ELSE
            Txt$ = Desc$ + CHR$(13) + CHR$(10)
        END IF
        IF INSTR(Txt$, "*Info*") > 0 THEN
            infomark = INSTR(Txt$, "*Info*")
            Txt$ = LEFT$(Txt$, infomark - 1)
            DO WHILE RIGHT$(Txt$, 1) = " "
                Txt$ = LEFT$(Txt$, LEN(Txt$) - 1)
            LOOP
            Txt$ = Txt$ + CHR$(13) + CHR$(10)
        END IF
        'IF LEFT$(Txt$, 1) = "*" THEN
        '    PRINT #2, MID$(Txt$, 2, LEN(Txt$));
        'ELSE
            PRINT #2, Txt$;
        'END IF
        IF EOF(1) THEN EXIT DO
    LOOP

    CALL Phweep
    LOCATE , 1
    PRINT "Created ... "; OutFile$; "!"

FUNCTION ChangeFileExt$ (FileName$, NewExt$)
    Extension = INSTR(FileName$, ".")
    IF Extension > 0 THEN
        ChangeFileExt$ = LEFT$(FileName$, Extension - 1) + "." + NewExt$
    ELSE
        ChangeFileExt$ = FileName$ + "." + NewExt$
    END IF
END FUNCTION

SUB Logo
    PRINT
    PRINT "FileData - (c)Copyright MotherShip Portholes 1993"
    PRINT "            by Mark H Butler, all rights reserved. "
END SUB

