
DEFINT A-Z
'********** These 2 are for Mode 13 only
DECLARE SUB Normal ()
DECLARE SUB BackDrop (x)
DECLARE SUB ClearToBlack ()
DECLARE SUB SaveFontToDisk ()
'***************************************
DECLARE SUB LoadFont (a$)
DECLARE SUB Pause (Ticks%)
DECLARE FUNCTION Fexist (File$)
DECLARE SUB FindMode (Mode, x, y)
'** Font Display routines
DECLARE SUB OldPrint (a$, x, y, Clur, size)
DECLARE SUB BigPrint (a$, x, y, Clur, size)
DECLARE SUB HugePrint (a$, x, y, Clur, size)
DECLARE SUB CurlyPrint (a$, x, y, Clur, size)
DECLARE SUB CurlyHugePrint (a$, x, y, Clur, size)
DECLARE SUB BigPrint.Shadow (a$, x, y, Clur, size)
DECLARE SUB CurlyPrint.Shadow (a$, x, y, Clur, size)
DECLARE SUB DoublePrint (word$, xx%, yy%, Clur%, Mode)
DECLARE SUB CloudPrint (word$, x, y, Clur, bgclur, size)
DECLARE SUB CornPrint (word$, xx%, yy%, Clur%, Sie, Mode)
DECLARE SUB SpacePrint (word$, xx%, yy%, Clur%, size, Mode)
DECLARE SUB FontPrint (word$, Textxx%, TExtyy%, Clur%, size, Mode)
DECLARE SUB BoldPrint (word$, Textxx%, TExtyy%, Clur%, size, Mode)
DECLARE SUB BloodPRINT (word$, Textxx%, TExtyy%, Clur%, size, Mode)
DECLARE SUB ThreeDPRINT (word$, xx%, yy%, fgclur%, bgclur%, size, Mode)
DECLARE SUB FontPrint.Shadow (word$, Textxx, TExtyy, Clur, Shadow, Mode)
DECLARE SUB GhostPrint (word$, xx%, yy%, fgclur%, bgclur%, size, Mode)
DECLARE SUB MountainPrint (word$, Textxx%, TExtyy%, fgclur%, bgclur%, size, Mode)

'**These subs are used by some of the Print routines Build from them
DECLARE SUB Code.C (a$, xx%, yy%, Clur%, size%)
DECLARE SUB Code.d (dfnt$, xx%, yy%, Clur%, size%)
DECLARE SUB Code.dC (a$, xx%, yy%, Clur%, size%)
DECLARE SUB Code.x (dfnt$, xx%, yy%, Clur%, size%)
DECLARE SUB Code.Old (a$, x, y, Clur, size)

DECLARE SUB Demo ()
DIM SHARED Arrayx$(256)    ' Array to Hold the font
PRINT "FONTED DEMO FOR QBFONTS V1.00b"
PRINT
LOCATE , , 1, 7
IF NOT Fexist("FONTED.CFG") THEN
 PRINT "The File Fonted.Cfg is not Found "
 PRINT "Can I create it now Y/n ? ";
redo:
 a$ = INPUT$(1)
 a$ = UCASE$(a$)
 IF a$ <> "Y" AND a$ <> "N" AND a$ <> CHR$(13) THEN GOTO redo
 IF a$ = CHR$(13) THEN a$ = "Y"
 PRINT a$
 IF UCASE$(a$) = "N" THEN END
 SaveFontToDisk
END IF
SCREEN 13
BackDrop 1
ClearToBlack
SCREEN 13
LoadFont "FONTED.CFG"
ThreeDPRINT "SRD SoftWare", 6, 2, 12, 4, 3, 13
ThreeDPRINT "Presents", 10, 7, 9, 1, 3, 13
ThreeDPRINT "QBFONTS", 14, 9, 11, 1, 3, 13
Pause 12
Demo
Pause 20
SCREEN 13
PALETTE
BackDrop 1
ClearToBlack

Normal

SUB BackDrop (xx)
g = 16
FOR x = 0 TO 200
  g = g + 1
  IF g > 30 THEN
   g = 16
   'SOUND 300, .09
   IF xx THEN Pause 1
  END IF
  LINE (0, x)-(320, x), g
NEXT x
END SUB

SUB BigPrint (a$, x, y, Clur, size)
FOR WordList = 1 TO LEN(a$)
 g = ASC(MID$(a$, WordList, 1))
 g$ = Arrayx$(g)
  Code.x g$, x, y, Clur, size
 x = x + 40
NEXT WordList
END SUB

SUB BigPrint.Shadow (a$, x, y, Clur, size)
FOR WordList = 1 TO LEN(a$)
 g = ASC(MID$(a$, WordList, 1))
 g$ = Arrayx$(g)
 Code.x g$, x + 2, y + 2, 8, size
 Code.x g$, x, y, Clur, size
 x = x + 40
NEXT WordList
END SUB

SUB BloodPRINT (word$, xx%, yy%, Clur%, size, Mode)
FindMode Mode, xx%, yy%
IF size < 1 THEN size = 1
IF size = 1 THEN
FOR WordList = 1 TO LEN(word$)
dfnt$ = ""
 g$ = MID$(word$, WordList, 1)
 Number = ASC(g$)
 dfnt$ = Arrayx$(Number)
FOR x = 0 TO 8
 FOR y = 0 TO 8
  k = k + 1
  IF MID$(dfnt$, k, 1) <> "0" THEN
    PSET (x + xx + NextLetter, y + yy), Clur
    PSET (x + xx + NextLetter, y + yy + 1), Clur
    IF x MOD 2 THEN PSET (x + xx + NextLetter, y + yy + 3), 12
  END IF
  NEXT y
NEXT x
k = 0
NextLetter = NextLetter + 8
NEXT WordList
ELSE
FOR WordList = 1 TO LEN(word$)
dfnt$ = ""
 g$ = MID$(word$, WordList, 1)
 Number = ASC(g$)
 dfnt$ = Arrayx$(Number)
FOR x = 0 TO (8 * size) STEP size
 FOR y = 0 TO (8 * size) STEP size
 k = k + 1
  IF MID$(dfnt$, k, 1) <> "0" THEN
    IF x MOD (2 * size) THEN LINE (x + xx + NextLetter, y + yy)-(x + xx + NextLetter, y + yy + (size * size + 1)), 12
     LINE (x + xx + NextLetter, y + yy)-(x + xx + NextLetter + size, y + yy + size), Clur, BF
  END IF
  NEXT y
NEXT x
k = 0
NextLetter = NextLetter + (8 * size)
NEXT WordList
END IF

END SUB

SUB BoldPrint (word$, xx%, yy%, Clur%, size, Mode)
FindMode Mode, xx%, yy%
IF size = 1 THEN
FOR WordList = 1 TO LEN(word$)
dfnt$ = ""
 g$ = MID$(word$, WordList, 1)
 Number = ASC(g$)
 dfnt$ = Arrayx$(Number)
FOR x = 0 TO 8
 FOR y = 0 TO 8
  k = k + 1
  IF MID$(dfnt$, k, 1) <> "0" THEN
    PSET (x + xx + NextLetter, y + yy), Clur
    PSET (x + xx + NextLetter, y + yy + 1), Clur
  END IF
  NEXT y
NEXT x
k = 0
NextLetter = NextLetter + 8
NEXT WordList
ELSE
FOR WordList = 1 TO LEN(word$)
dfnt$ = ""
 g$ = MID$(word$, WordList, 1)
 Number = ASC(g$)
 dfnt$ = Arrayx$(Number)
FOR x = 0 TO (8 * size) STEP size
 FOR y = 0 TO (8 * size) STEP size
   k = k + 1
    'IF MID$(dfnt$, k, 1) <> "0" THEN LINE (x + xx + NextLetter, Y + yy)-(x + xx + NextLetter + Size, Y + yy + Size), clur, BF
    IF MID$(dfnt$, k, 1) <> "0" THEN LINE (x + xx + NextLetter, y + yy)-(x + xx + NextLetter + size + 1, y + yy + size + 1), Clur, BF
 NEXT y
NEXT x
k = 0
NextLetter = NextLetter + (8 * size)
NEXT WordList

END IF
END SUB

SUB ClearToBlack
FOR x = 200 TO 0 STEP -1
  IF j > 10 THEN Pause 1: j = 0
  LINE (0, x)-(320, x), 0
  j = j + 1
NEXT x
END SUB

SUB CloudPrint (a$, x, y, Clur, bgclur, size)
FOR WordList = 1 TO LEN(a$)
dfnt$ = ""
 g$ = MID$(a$, WordList, 1)
 CurlyPrint g$, x + 2, y + 2, bgclur, size + 5
 CurlyPrint g$, x, y, Clur, size
NEXT WordList
END SUB

SUB Code.C (a$, xx, yy, Clur, size)
Clurr = Clur
FOR x = 1 + xx TO 41 + xx STEP 5
 FOR y = 1 + yy TO 44 + yy STEP 5
   k = k + 1
   IF Clur = -1 THEN Clurr = INT(RND * 15) + 1
   IF MID$(a$, k, 1) <> "0" THEN
      FOR t = 0 TO size STEP 3
       CIRCLE (x, y), t, Clurr
      NEXT t
   END IF
 NEXT y
NEXT x
END SUB

SUB Code.d (dfnt$, xx, yy, Clur, size)
Clurr = Clur
IF Clur = -1 THEN Clurr = INT(RND * 15) + 1
FOR x = 1 + xx TO 82 + xx STEP 10
 FOR y = 1 + yy TO 88 + yy STEP 10
   k = k + 1
   IF MID$(dfnt$, k, 1) <> "0" THEN LINE (x, y)-(x + size, y + size), Clurr, BF
 NEXT y
NEXT x
END SUB

SUB Code.dC (a$, xx, yy, Clur, size)
Clurr = Clur
FOR x = 1 + xx TO 82 + xx STEP 10
 FOR y = 1 + yy TO 88 + yy STEP 10
   k = k + 1
    IF Clur = -1 THEN Clurr = INT(RND * 15) + 1
   IF MID$(a$, k, 1) <> "0" THEN
     FOR t = 0 TO size STEP 2
       CIRCLE (x, y), t, Clurr
      NEXT t
   END IF
 NEXT y
NEXT x
END SUB

SUB Code.Old (dfnt$, xx, yy, Clur, size)

Clurr = Clur
IF Clur = -1 THEN Clurr = INT(RND * 15) + 1
FOR x = 1 + xx TO 41 + xx STEP 5
 FOR y = 1 + yy TO 44 + yy STEP 5
   k = k + 1
   L = INT(RND * 31) + 1
   IF y MOD L THEN
    IF MID$(dfnt$, k, 1) <> "0" THEN
      LINE (x, y)-(x + size, y + size), Clurr, BF
      CIRCLE (x, y), 2, Clurr
   END IF
   END IF
 NEXT y
NEXT x
END SUB

SUB Code.x (dfnt$, xx, yy, Clur, size)
Clurr = Clur
IF Clur = -1 THEN Clurr = INT(RND * 15) + 1
FOR x = 1 + xx TO 41 + xx STEP 5
 FOR y = 1 + yy TO 44 + yy STEP 5
   k = k + 1
   IF MID$(dfnt$, k, 1) <> "0" THEN LINE (x, y)-(x + size, y + size), Clurr, BF
 NEXT y
NEXT x
END SUB

SUB CornPrint (word$, xx%, yy%, Clur%, size, Mode)
FindMode Mode, xx%, yy%
IF size = 1 THEN
FOR WordList = 1 TO LEN(word$)
dfnt$ = ""
 g$ = MID$(word$, WordList, 1)
 Number = ASC(g$)
 dfnt$ = Arrayx$(Number)
FOR x = 0 TO 8
 FOR y = 0 TO 8
  k = k + 1
  IF MID$(dfnt$, k, 1) <> "0" THEN
    PSET (x + xx + NextLetter, y + yy), Clur
    PSET (x + xx + NextLetter, y + yy + 1), Clur
  END IF
  NEXT y
NEXT x
k = 0
NextLetter = NextLetter + 8
NEXT WordList
ELSE
FOR WordList = 1 TO LEN(word$)
dfnt$ = ""
 g$ = MID$(word$, WordList, 1)
 Number = ASC(g$)
 dfnt$ = Arrayx$(Number)
FOR x = 0 TO (8 * size) STEP size
 FOR y = 0 TO (8 * size) STEP size
   k = k + 1
    IF MID$(dfnt$, k, 1) <> "0" THEN LINE (x + xx + NextLetter, y + yy)-(x + xx + NextLetter + size, y + yy + size), Clur, B
    IF MID$(dfnt$, k, 1) <> "0" THEN LINE (x + xx + NextLetter, y + yy)-(x + xx + NextLetter + size + 1, y + yy + size + 1), Clur, B
 NEXT y
NEXT x
k = 0
NextLetter = NextLetter + (8 * size)
NEXT WordList

END IF

END SUB

SUB CurlyHugePrint (a$, x, y, Clur, size)
FOR WordList = 1 TO LEN(a$)
 g = ASC(MID$(a$, WordList, 1))
 g$ = Arrayx$(g)
  Code.dC g$, x, y, Clur, size
 x = x + 70
NEXT WordList
END SUB

SUB CurlyPrint (a$, x, y, Clur, size)
FOR WordList = 1 TO LEN(a$)
 g = ASC(MID$(a$, WordList, 1))
 g$ = Arrayx$(g)
  Code.C g$, x, y, Clur, size
 x = x + 40
NEXT WordList
END SUB

SUB CurlyPrint.Shadow (a$, x, y, Clur, size)
FOR WordList = 1 TO LEN(a$)
 g = ASC(MID$(a$, WordList, 1))
 g$ = Arrayx$(g)
  Code.C g$, x + 2, y + 2, 8, size
  Code.C g$, x, y, Clur, size
 x = x + 40
NEXT WordList

END SUB

SUB Demo
LoadFont "FONTED.CFG"
SCREEN 12
size = 15
LINE (0, 0)-(640, 480), 8, BF
MountainPrint "SRD SoftWare", 6, 2, 12, 4, 5, 12
MountainPrint "Presents", 10, 11, 9, 1, 4, 12
BigPrint.Shadow "QBFONTS", 60, 200, 1, 4
BigPrint.Shadow "QBFONTS", 55, 195, 9, 4
FontPrint "In Any Screen Mode!!", 20, 11, 9, 2, 12
FontPrint "This is Screen Mode 12 oops", 22, 11, 12, 1, 12
FontPrint "This is Screen Mode 12 That's Better", 24, 5, 10, 2, 12
Pause 12
LINE (0, 0)-(640, 480), 8, BF
MountainPrint "Some Fonts are for ", 6, 2, 12, 4, 2, 12
MountainPrint "Text Cords. and Some ", 10, 11, 9, 1, 2, 12
BigPrint.Shadow "ACT like", 60, 200, 1, 4
BigPrint.Shadow "ACT like", 55, 195, 9, 4
FontPrint "Line and Pset ", 20, 11, 9, 2, 12
FontPrint "So You can Call them From anywhere", 22, 11, 12, 1, 12
FontPrint "Just Fiddle With'em ENJOY", 24, 5, 10, 2, 12
Pause 22

SCREEN 13
FOR x = 16 TO 31
 k = k + 5
 BigPrint "QBFONTS", 1 + k, 1 + k, x, 8
NEXT x
OldPrint "QBFONTS", 10, 10, 12, 5
FOR x = 9 TO 15
 FontPrint.Shadow "How About a Shadowed Font ??", 5 + x, 1 + x, x, 8, 13
 Pause .05
NEXT x
CurlyPrint "QBFONTS", 10, 10, -1, 8
Clur = 16
FOR x = 1 TO 190 STEP 5
BigPrint "QBFONTS", 10, 10 + x, Clur, 5
Clur = Clur + 1
NEXT x
Clur = 16
FOR x = 190 TO 1 STEP -5
BigPrint "QBFONTS", 10, 10 + x, Clur, 5
Clur = Clur + 1
NEXT x
CurlyPrint "QBFONTS", 10, 80, 12, 7
BigPrint "QBFONTS", 10, 80, 0, 5
Pause 1
FOR x = 1 TO 130
 PALETTE x, 0
NEXT x
SCREEN 9
CurlyHugePrint "QBFONTS", 10, 10, -1, 6
CloudPrint "SRD SoftWare", 50, 150, -1, 15, 4
BigPrint "Proveing", 150, 190, -1, 5
BigPrint "Basic Is Fun!", 60, 250, -1, 5
LOCATE 25, 30: PRINT "Press any Key";
DO UNTIL LEN(INKEY$)
 FOR g = 1 TO 14
 x = INT(RND * 14) + 1
 PALETTE x, g
 NEXT g
tc = tc + 1
IF tc > 50 THEN PALETTE: tc = 0
LOOP
a$ = INKEY$
SCREEN 13
FOR x = 1 TO 100
 xx = x + 15
 LINE (1, x)-(320, x), xx
NEXT x
FOR x = 200 TO 100 STEP -1
 t = t + 1
 xx = t + 15
 LINE (1, x)-(320, x), xx
NEXT x
FOR x = 15 TO 130
 PALETTE x, 0
NEXT x
BigPrint.Shadow "QBFONTS", 10, 40, 1, 8
CurlyPrint.Shadow "IS", 100, 90, 11, 4
BigPrint.Shadow "FREEWARE", -3, 135, 14, 4
FOR x = 140 TO 15 STEP -1
 PALETTE x, 63
 Pause .009
NEXT x
Pause 3
END SUB

SUB DoublePrint (word$, xx%, yy%, Clur%, Mode)
FindMode Mode, xx%, yy%
FOR WordList = 1 TO LEN(word$)
dfnt$ = ""
 g$ = MID$(word$, WordList, 1)
 Number = ASC(g$)
 dfnt$ = Arrayx$(Number)
FOR x = 0 TO 16 STEP 2
 FOR y = 0 TO 16 STEP 2
  k = k + 1
  IF MID$(dfnt$, k, 1) <> "0" THEN
     LINE (x + xx + NextLetter - 4, y + yy)-(x + xx + NextLetter, y + yy + 2), Clur, BF
     'LINE (x + xx + NextLetter, y + yy)-(x + xx + NextLetter + 1, y + yy + 1), clur, B
  END IF
  NEXT y
NEXT x
k = 0
NextLetter = NextLetter + 16
NEXT WordList

END SUB

FUNCTION Fexist (File$)
ON LOCAL ERROR GOTO FunctionFexistError
   IF LEN(DIR$(File$)) THEN
    Fexist = -1
   ELSE
    Fexist = 0
   END IF
EXIT FUNCTION
FunctionFexistError:
EXIT FUNCTION
RESUME NEXT
END FUNCTION

SUB FindMode (Mode, xx, yy)

IF Mode = 7 OR Mode = 8 OR Mode = 13 THEN
 SWAP xx, yy            '<
 yy = yy - 1            '*
 xx = xx - 1            '*  Screen 7 - 8 - 13
 xx = ((xx) * 8) - 1: yy = ((yy) * 8) - 1    '<
END IF
IF Mode = 9 THEN
 SWAP xx, yy             '<
 xx = xx - 1             '*  Screen 9
 xx = ((xx) * 8) - 1     '*
 yy = yy - 1: yy = ((yy) * 14) + 2    '<
END IF
IF Mode = 12 THEN
 SWAP xx, yy             '<
 xx = xx - 1             '*  Screen 12
 xx = ((xx) * 8) - 1     '*
 yy = yy - 1: yy = ((yy) * 16) + 2    '<
END IF
END SUB

SUB FontPrint (word$, xx, yy, Clur, size, Mode)
FindMode Mode, xx, yy
IF size = 1 THEN
FOR WordList = 1 TO LEN(word$)
dfnt$ = ""
 g$ = MID$(word$, WordList, 1)
 Number = ASC(g$)
 dfnt$ = Arrayx$(Number)
FOR x = 0 TO 8
 FOR y = 0 TO 8
   k = k + 1
   IF MID$(dfnt$, k, 1) <> "0" THEN PSET (x + xx + NextLetter, y + yy), Clur
 NEXT y
NEXT x
k = 0
NextLetter = NextLetter + 8
NEXT WordList
ELSE

FOR WordList = 1 TO LEN(word$)
dfnt$ = ""
 g$ = MID$(word$, WordList, 1)
 Number = ASC(g$)
 dfnt$ = Arrayx$(Number)
FOR x = 0 TO (8 * size) STEP size
 FOR y = 0 TO (8 * size) STEP size
   k = k + 1
   'IF MID$(dfnt$, k, 1) <> "0" THEN PSET (x + xx + NextLetter, Y + yy), clur
    IF MID$(dfnt$, k, 1) <> "0" THEN LINE (x + xx + NextLetter, y + yy)-(x + xx + NextLetter + size, y + yy + size), Clur, BF
 NEXT y
NEXT x
k = 0
NextLetter = NextLetter + (8 * size)
NEXT WordList
END IF
END SUB

SUB FontPrint.Shadow (word$, xx, yy, Clur, Shadow, Mode)
FindMode Mode, xx, yy
FOR WordList = 1 TO LEN(word$)
dfnt$ = ""
 g$ = MID$(word$, WordList, 1)
 Number = ASC(g$)
 dfnt$ = Arrayx$(Number)
FOR x = 0 TO 8
 FOR y = 0 TO 8
  k = k + 1
  IF MID$(dfnt$, k, 1) <> "0" THEN
    PSET (x + xx + NextLetter + 2, y + yy + 2), Shadow
    PSET (x + xx + NextLetter, y + yy), Clur
  END IF
  NEXT y
NEXT x
k = 0
NextLetter = NextLetter + 8
NEXT WordList
END SUB

SUB GhostPrint (word$, xx, yy, fgclur%, bgclur%, size, Mode)
Shadow = Mode + size
FindMode Mode, xx, yy
FOR WordList = 1 TO LEN(word$)
dfnt$ = ""
 g$ = MID$(word$, WordList, 1)
 Number = ASC(g$)
 dfnt$ = Arrayx$(Number)
FOR x = 0 TO (8 * size) STEP size
 FOR y = 0 TO (8 * size) STEP size
  k = k + 1
  IF MID$(dfnt$, k, 1) <> "0" THEN
    LINE (x + xx + NextLetter, y + yy)-(x + xx + NextLetter - Shadow + size, y + yy - Shadow - size), fgclur%
    LINE (x + xx + NextLetter, y + yy)-(x + xx + NextLetter - Shadow + size - 2, y + yy - Shadow - size - 2), bgclur%
  END IF
  NEXT y
NEXT x
k = 0
NextLetter = NextLetter + (8 * size)
NEXT WordList


END SUB

SUB HugePrint (a$, x, y, Clur, size)
FOR WordList = 1 TO LEN(a$)
 g = ASC(MID$(a$, WordList, 1))
 g$ = Arrayx$(g)
  Code.d g$, x, y, Clur, size
 x = x + 70
NEXT WordList
END SUB

SUB LoadFont (a$)
IF Fexist(a$) THEN
NextFile = FREEFILE
OPEN a$ FOR BINARY AS #NextFile
FOR xx = 32 TO 127                       'created by the editor
 a$ = INPUT$(81, #NextFile)                    '
 Arrayx$(xx) = a$                       '
NEXT xx                                 '
CLOSE #NextFile                                'END of Loading
END IF
END SUB

SUB MountainPrint (word$, xx%, yy%, fgclur%, bgclur%, size, Mode)
Shadow = 15
FindMode Mode, xx%, yy%
FOR WordList = 1 TO LEN(word$)
dfnt$ = ""
 g$ = MID$(word$, WordList, 1)
 Number = ASC(g$)
 dfnt$ = Arrayx$(Number)
FOR x = 0 TO (8 * size) STEP size
 FOR y = 0 TO (8 * size) STEP size

  k = k + 1
  IF MID$(dfnt$, k, 1) <> "0" THEN
   
    LINE (x + xx + NextLetter, y + yy)-(x + xx + NextLetter + Shadow + size, y + yy + Shadow + size), bgclur%
    LINE (x + xx + NextLetter, y + yy)-(x + xx + NextLetter + 1 + size, y + yy + 1 + size), fgclur%, BF
  END IF
  NEXT y
NEXT x
k = 0
NextLetter = NextLetter + (8 * size)
NEXT WordList
END SUB

SUB Normal
SCREEN 0
WIDTH 80
END SUB

SUB OldPrint (a$, x, y, Clur, size)
FOR WordList = 1 TO LEN(a$)
 g = ASC(MID$(a$, WordList, 1))
 g$ = Arrayx$(g)
  Code.Old g$, x, y, Clur, size
 x = x + 40
NEXT WordList
END SUB

 SUB Pause (Ticks%)
    DEF SEG = 0
    DO UNTIL TestTick% > Ticks%
        'IF LEN(INKEY$) THEN EXIT SUB
        LastTick% = GetTick%
        GetTick% = PEEK(&H46C)
        IF LastTick% <> GetTick% THEN
            TestTick% = TestTick% + 1
        END IF
    LOOP
    DEF SEG
 END SUB

SUB SaveFontToDisk
SCREEN 7
COLOR 14
LOCATE 12, 1: PRINT "Creating FONTED.CFG   <-----"
COLOR 1
OPEN "FONTED.CFG" FOR OUTPUT AS #2
FOR xx = 32 TO 127
  LOCATE 12, 21
  PRINT CHR$(xx)
FOR x = 159 TO 167
FOR y = 87 TO 95
  g = g + 1
  g$ = g$ + LTRIM$(RTRIM$(STR$(POINT(x, y))))
  NEXT y
NEXT x
PRINT #2, g$;
g$ = ""
NEXT xx
CLOSE #2
END SUB

SUB SpacePrint (word$, xx%, yy%, Clur%, size, Mode)
FindMode Mode, xx%, yy%
IF size = 1 THEN
FOR WordList = 1 TO LEN(word$)
dfnt$ = ""
 g$ = MID$(word$, WordList, 1)
 Number = ASC(g$)
 dfnt$ = Arrayx$(Number)
FOR x = 0 TO 8
 FOR y = 0 TO 8
  k = k + 1
  IF MID$(dfnt$, k, 1) <> "0" THEN
    PSET (x + xx + NextLetter, y + yy), Clur
    PSET (x + xx + NextLetter, y + yy + 1), Clur
  END IF
  NEXT y
NEXT x
k = 0
NextLetter = NextLetter + 8
NEXT WordList
ELSE
FOR WordList = 1 TO LEN(word$)
dfnt$ = ""
 g$ = MID$(word$, WordList, 1)
 Number = ASC(g$)
 dfnt$ = Arrayx$(Number)
FOR x = 0 TO (8 * size) STEP size
 FOR y = 0 TO (8 * size) STEP size
   k = k + 1
    IF MID$(dfnt$, k, 1) <> "0" THEN LINE (x + xx + NextLetter, y + yy)-(x + xx + NextLetter + size, y + yy + size), Clur
 NEXT y
NEXT x
k = 0
NextLetter = NextLetter + (8 * size)
NEXT WordList

END IF

END SUB

SUB ThreeDPRINT (word$, xx%, yy%, fgclur%, bgclur%, size, Mode)
Shadow = Mode + size
FindMode Mode, xx, yy
FOR WordList = 1 TO LEN(word$)
dfnt$ = ""
 g$ = MID$(word$, WordList, 1)
 Number = ASC(g$)
 dfnt$ = Arrayx$(Number)
FOR x = 0 TO (8 * size) STEP size
 FOR y = 0 TO (8 * size) STEP size

  k = k + 1
  IF MID$(dfnt$, k, 1) <> "0" THEN

    LINE (x + xx + NextLetter, y + yy)-(x + xx + NextLetter + Shadow + size, y + yy + Shadow + size), bgclur%
    LINE (x + xx + NextLetter, y + yy + 3)-(x + xx + NextLetter + Shadow + size, y + yy + Shadow + size + 2), bgclur%
    LINE (x + xx + NextLetter + Shadow, y + yy + Shadow)-(x + xx + NextLetter + 1 + size + Shadow, y + yy + 1 + size + Shadow), fgclur%
    LINE (x + xx + NextLetter, y + yy)-(x + xx + NextLetter + 1 + size, y + yy + 1 + size), fgclur%, BF

  END IF
  NEXT y
NEXT x
k = 0
NextLetter = NextLetter + (8 * size)
NEXT WordList

END SUB

