TYPE FileInfo
        FileAttribute AS STRING * 1
        FileTime AS INTEGER
        FileDate AS INTEGER
        FileSize AS LONG
        Filename AS STRING * 13
END TYPE
'Constants for the FileAttribute above.  Use OR when combining.
CONST AttrNormal = 0
CONST AttrReadOnly = 1
CONST AttrHidden = 2
CONST AttrSystem = 4
CONST AttrVolumeLabel = 8
CONST AttrDirectory = 16
CONST AttrArchive = 32

DECLARE FUNCTION Exists% (Filename$)
DECLARE FUNCTION CurrentDrive$ ()
DECLARE FUNCTION CHDrive$ (Drive$)
DECLARE FUNCTION CurDir$ (Drive$)
DECLARE FUNCTION DriveType% (BYVAL Drive%)
DECLARE FUNCTION VolLabel% (BYVAL Drive%, Label$)
DECLARE FUNCTION VolLabelDel% (BYVAL Drive%)
DECLARE FUNCTION ME$ ()
DECLARE FUNCTION GetPSP% ()
DECLARE FUNCTION CmdLine$ ()
DECLARE FUNCTION FindFirst% (Filename$, BYVAL Attribute%, Info AS FileInfo)
DECLARE FUNCTION FindNext% (Info AS FileInfo)

DECLARE FUNCTION DetectPort% ALIAS "Detect_Game_Port" ()
DECLARE FUNCTION JoyStickButtons% ALIAS "Button_Status" ()
'Button masks for JoyStickButtons function, use OR when combining
CONST Joy1Butt1 = 1
CONST Joy1Butt2 = 2
CONST Joy2Butt1 = 4
CONST Joy2Butt2 = 8
DECLARE SUB Read1 ALIAS "Read_1_JoyStick" (X1%, Y1%)
DECLARE SUB Read2 ALIAS "Read_2_Joysticks" (X1%, Y1%, X2%, Y2%)

DECLARE FUNCTION IsStacker% ALIAS "DetectStacker" ()
DECLARE FUNCTION StackerDrive (BYVAL DriveNo%)

DECLARE SUB MemMove (SRCSEG%, SRCOFFSET%, DSTSEG%, DSTOFFSET%, BYTES%)

DECLARE FUNCTION RInstr% (Source$, Search$)
