; MEMCOPY.ASM by Matt Hart
;
; CALL MemCopy (BYVAL FromSeg, BYVAL FromAddr, BYVAL ToSeg,_
;               BYVAL ToAddr, BYVAL NumBytes)
;
;All parameters must be integers

.Model Medium,BASIC
.Code

MemCopy PROC USES DS ES SI DI, FSeg:Ptr, FAdr:Ptr, TSeg:Ptr, TAdr:Ptr,
NumBytes:Ptr
    CLD                    ;Forward move

    MOV  SI,FAdr           ;FAdr into SI register
    MOV  ES,TSeg           ;TSeg into ES register
    MOV  DI,TAdr           ;TAdr into DI register
    MOV  CX,NumBytes       ;Put NumBytes into CX register
    MOV  BX,FSeg           ;FSeg value

    PUSH DS                ;Save DS to restore after move
    MOV  DS,BX             ;Put FSeg into DS register
    REP  Movsb             ;Move DS,SI to ES,DI
    POP  DS                ;Restore DS

    RET                    ;return to BASIC
MemCopy ENDP
END
