DEFINT A-Z
'$INCLUDE: 'FIDO.BI'
'$INCLUDE: 'MISC.BI'
'$DYNAMIC
DECLARE FUNCTION OriginalFileName$ ()
DECLARE FUNCTION DIR$ (FileSpec$)
DECLARE FUNCTION Month$ (MonthNo)

REM $STATIC
SUB AddMessageToPacket (From$, FA AS Address, ToName$, TA AS Address, Subject$, Text$, T AS TimeStruct)
   'Adds a message to the current packet.
   DIM Mh AS MessageHeader
   Mh.Header = CHR$(2)
   Mh.NullStr = CHR$(0)
   Mh.OrigNode = FA.Node
   Mh.DestNode = TA.Node
   Mh.OrigNet = FA.Net
   Mh.DestNet = TA.Net
   Mh.Attributes = 16
   Mh.Cost = 15
   day$ = MID$(DATE$, 4, 2) + " "
   Mo$ = LEFT$(Month$(VAL(LEFT$(DATE$, 2))), 3) + " "
   year$ = RIGHT$(DATE$, 2) + "  "
   Mh.DateTime = day$ + Mo$ + year$ + TIME$
   PUT #3, , Mh
   PUT #3, , From$
   PUT #3, , ToName$
   PUT #3, , Subject$
   PUT #3, , Text$
END SUB

SUB ClosePacket
   EndOfPkt$ = CHR$(0) + CHR$(0)
   PUT #3, , EndOfPkt$
   CLOSE #3
END SUB

SUB CreatePacket (P AS FSC0039)
   SHARED F
   F = FREEFILE
   PRINT F
   Name$ = OriginalFileName$
   OPEN Name$ FOR BINARY AS 3
   PUT #3, , P
END SUB

FUNCTION OriginalFileName$
   FirstPart$ = "FRMQWK"
   SecondPart = 0
   ThirdPart = 0
   EXT$ = ".PKT"
   DO WHILE LEN(DIR$(FirstPart$ + LTRIM$(STR$(SecondPart)) + LTRIM$(STR$(ThirdPart)) + EXT$))
      ThirdPart = ThirdPart + 1
      IF ThirdPart > 9 THEN
         ThirdPart = 0
         SecondPart = SecondPart + 1
      END IF
   LOOP

   OriginalFileName$ = FirstPart$ + LTRIM$(STR$(SecondPart)) + LTRIM$(STR$(ThirdPart)) + EXT$
END FUNCTION

