TYPE QWKHeader
        StatusFlag      AS STRING * 1   'Message status flag
                                        ' " " = public, unread
                                        ' "-" = public, read
                                        ' "*" = private, read by someone,
                                        '       but not by intended recipient
                                        ' "+" = private, read by official
                                        '       recipient
                                        ' "~" = comment to Sysop, unread
                                        ' "`" = comment to Sysop, read
                                        ' "%" = sender password protected,
                                        '       unread
                                        ' "^" = sender password protected,
                                        '       read
                                        ' "!" = group password protected,
                                        '       unread
                                        ' "#" = group password protected,
                                        '       read
                                        ' "$" = group password protected,
                                        '       to all
        MessageNumber   AS STRING * 7   ' Message number (in ASCII)
        MsgDate         AS STRING * 8   ' date, (mm-dd-yy, in ASCII)
        MsgTime         AS STRING * 5   ' time, (hh:mm, in ASCII)
        ToName          AS STRING * 25  ' To (uppercase, left justified)
        From            AS STRING * 25  ' From (uppercase, left justified)
        Subject         AS STRING * 25  ' Subject (mixed case)
        Password        AS STRING * 12  ' Password (space filled)
        ReferenceNo     AS STRING * 8   ' Reference message number (in ASCII)
        NumOfBlocks     AS STRING * 6   ' number of 128-byte blocks in
                                        ' message (including the header, in
                                        ' ASCII; the lowest value should be 2
                                        ' header plus one block message; this
                                        ' number may not be left flushed
                                        ' withing the field)
        Flag            AS STRING * 1   ' ASCII 225 means the message is
                                        ' active; ASCII 226 means this
                                        ' message is to be killed)
        ConferenceNum   AS INTEGER      ' Conference number (unsigned)
        LogicalMsgNum   AS INTEGER      ' Logical message in the current
                                        ' packet; i.e. this numbe will be 1
                                        ' for the first message, 2 for the
                                        ' second, and so on. (unsigned)
        NetTagline      AS STRING * 1   ' Indicates whether the message has
                                        ' a network tagline or not.  A value
                                        ' of '*' indicates that a network tag-
                                        ' line is present; a value of ' '
                                        ' (space) indicates that there isn't
                                        ' one.  Messages sent to readers
                                        ' (non-net-status) generally leave
                                        ' this as a space.  Only network
                                        ' softwares need this information.
END TYPE
