DEFINT A-Z
DECLARE SUB GetKee (Keycode, Keycode$)
DECLARE SUB Show (Row, Column, Card$)
DECLARE SUB GetValue (Card$, Value)
DECLARE SUB HighestCard (Highest, First, Second, CardValue())
REDIM Card$(52), CardValue(5), Discard(5), Column(5)
Column(1) = 3: Column(2) = 13: Column(3) = 23: Column(4) = 33: Column(5) = 43
A$ = " A 2 3 4 5 6 7 8 910 J Q K "
MaxDiscards = 4: Row = 9
DO
    J = 1
    FOR X = 1 TO 13
       Card$(X) = MID$(A$, J, 2)
       J = J + 2
    NEXT X
    FOR X = 1 TO 13
       Card$(X + 13) = Card$(X)
       Card$(X + 26) = Card$(X)
       Card$(X + 39) = Card$(X)
    NEXT X
    FOR X = 1 TO 52
       Card$(X) = Card$(X) + CHR$(((X - 1) \ 13) + 3)
    NEXT X
    RANDOMIZE TIMER
    FOR X = 1 TO 52
        J = INT((RND * 52) + 1)
        K = INT((RND * 52) + 1)
        SWAP Card$(J), Card$(K)
    NEXT X
    FOR X = 1 TO 5
        CALL GetValue(Card$(X), Value)
        CardValue(X) = Value
    NEXT
    COLOR 7, 0: CLS
    LOCATE , , 0
    CALL Show(2, 1, Card$(1))
    CALL Show(2, 11, Card$(2))
    CALL Show(2, 21, Card$(3))
    CALL Show(2, 31, Card$(4))
    CALL Show(2, 41, Card$(5))
    COLOR 3, 0
    LOCATE 25, 1: PRINT "["; CHR$(27); CHR$(26); "]Move  [Spacebar] Mark/Unmark Discards  [Enter]Play";
    FOR X = 1 TO 5: Discard(X) = 0: NEXT
    X = 1: Count = 0
    DO
        COLOR 14, 0
        LOCATE Row, Column(X): PRINT CHR$(24);
        CALL GetKee(Keycode, Keycode$)
        LOCATE Row, Column(X): PRINT " ";
        SELECT CASE Keycode
            CASE -75
                IF X > 1 THEN X = X - 1
            CASE -77
                IF X < 5 THEN X = X + 1
            CASE 32
                IF Discard(X) THEN
                    Discard(X) = 0
                    Count = Count - 1
                    COLOR 7, 0
                    LOCATE Row - 1, Column(X): PRINT " ";
                ELSE
                    IF Count < MaxDiscards THEN
                        Count = Count + 1
                        Discard(X) = -1
                        COLOR 2, 0
                        LOCATE Row - 1, Column(X): PRINT "X";
                    ELSE
                        SOUND 1000, 1
                    END IF
                END IF
        END SELECT
    LOOP UNTIL Keycode = 13 OR Keycode = 27
    IF Keycode = 27 THEN COLOR 7, 0: CLS : END
    COLOR 3, 0
    LOCATE Row - 1, 1: PRINT SPACE$(80);
    LOCATE 25, 1: PRINT "[D]eal  [Q]uit"; SPACE$(50);
    FOR X = 1 TO 5
        IF Discard(X) THEN
            SWAP Card$(X), Card$(X + 5)
        END IF
    NEXT
    CALL Show(2, 1, Card$(1))
    CALL Show(2, 11, Card$(2))
    CALL Show(2, 21, Card$(3))
    CALL Show(2, 31, Card$(4))
    CALL Show(2, 41, Card$(5))
    DO
        CALL GetKee(Keycode, Keycode$)
    LOOP UNTIL Keycode = 27 OR Keycode$ = "Q" OR Keycode$ = "D"
    IF Keycode = 27 OR Keycode$ = "Q" THEN EXIT DO
LOOP
COLOR 7, 0: CLS
END
 
'{EOF}==================================================================

SUB GetKee (Keycode, Keycode$)
 
    DO
        Keycode$ = INKEY$
    LOOP UNTIL LEN(Keycode$)
    IF LEN(Keycode$) = 2 THEN
        Keycode = -ASC(RIGHT$(Keycode$, 1))
    ELSE
        Keycode = ASC(Keycode$)
    END IF
    Keycode$ = UCASE$(Keycode$)
 
END SUB

SUB GetValue (Card$, Value)
 
    Value$ = MID$(Card$, 2, 1)
    SELECT CASE Value$
        CASE "A"
            Value = 14
        CASE "K"
            Value = 13
        CASE "Q"
            Value = 12
        CASE "J"
            Value = 11
        CASE "0"
            Value = 10
        CASE ELSE
            Value = ASC(Value$) - 48
    END SELECT
    
END SUB

SUB HighestCard (Highest, First, Second, CardValue())
 
    IF CardValue(First) > CardValue(Second) THEN Highest = 1
    IF CardValue(First) < CardValue(Second) THEN Highest = 2
    IF CardValue(First) = CardValue(Second) THEN Highest = 0
 
END SUB

SUB Show (Row, Column, Card$)
 
    Suit$ = MID$(Card$, 3, 1)
    SELECT CASE ASC(Suit$)
        CASE 3
            Fg = 4
        CASE 4
            Fg = 4
        CASE 5
            Fg = 0
        CASE 6
            Fg = 0
    END SELECT
    COLOR 0, 7
    LOCATE Row, Column
    COLOR 9, 7: PRINT ""
    LOCATE Row + 1, Column
    COLOR 9, 7: PRINT "       "
    LOCATE Row + 2, Column
    COLOR 9, 7: PRINT "       "
    LOCATE Row + 3, Column
    COLOR 9, 7: PRINT "       "
    LOCATE Row + 4, Column
    COLOR 9, 7: PRINT "       "
    LOCATE Row + 4, Column
    COLOR 9, 7: PRINT ""
    LOCATE Row + 1, Column
    COLOR Fg, 7: PRINT LTRIM$(Card$)
    LOCATE Row + 4, Column + 4
    COLOR Fg, 7: PRINT RTRIM$(Card$)
 
END SUB

