' 16-04-93. 11:02:29 VIRSCRN.BAS
'
'PROGRAM : Virtual Screens with TYPES
'AUTHOR  : Thaddy de Koning
'PURPOSE : Provides two routines to get an infinite number of independent
' 			  virualscreen area's. Working, but NOT FINISHED YET
'          I want to expand on it with CHUCK and PLUCK, to enable fully
'          independent screen save/restore to the virtual screens.
'ONLY POWERBASIC 3.00B, the ASM WILL CRASH IN 3.00A.

$LIB ALL OFF
$STRING 4
DEFINT A-Z

%FALSE = 0
%TRUE = NOT %FALSE

'What this TYPE does, is providing a framework to pass all variables
'related to a particular screen at once.
'
TYPE VirScreen
			UpperRow AS BYTE
	  NumberOfRows AS BYTE
		 LeftColumn AS BYTE
  NumberOfColumns AS BYTE
			 Xcursor AS BYTE
			 Ycursor AS BYTE
				 Fore AS BYTE
				 BACK AS BYTE
' OFFSET AS WORD    'I want to use this for Erik's
' SEGMENT AS WORD   'Chuck and Pluck, to enable screen save/restore
						  'Why not normal screensave/restore?
						  'Can't be typed, Unless The whole screen is saved.
						  'In this case that would damage the contents of
						  'the other virual screens. (variable length)
END TYPE

DIM Screen1 AS SHARED Virscreen  'SHARED means we can access it from
DIM Screen2 AS SHARED Virscreen  'anyware in the program.


'This defines screen1
'
Screen1.UpperRow = 2
Screen1.LeftColumn = 2
Screen1.NumberOfRows = 10
Screen1.NumberOfColumns = 30
Screen1.Xcursor = 1
Screen1.Ycursor = 1
Screen1.Fore = 0
Screen1.Back = 7

'This defines screen2
'
Screen2.UpperRow = 12
Screen2.LeftColumn = 41
Screen2.NumberOfRows = 5
Screen2.NumberOfColumns = 30
Screen2.Xcursor = 1
Screen2.Ycursor = 1
Screen2.Fore = 7
Screen2.Back = 0

'This is a demo

COLOR 15,1
CLS
FOR X? = 1 TO 25
PRINT STRING$(80,chr$(176));
NEXT

Openscreen screen1    'establishes screen1 and clears to default color
CLS TEXT
Openscreen screen2    'same for screen2
CLS TEXT

FOR X? = 1 TO 5
  Openscreen screen1
  PRINT "This is screen 1"
  PRINT "Type 'stop' to end "
  INPUT "Type a few words :";a$
  CloseScreen screen1
  Openscreen  screen2
  INCR Screen2.Fore            'Shows dynamically changing vars in a screen
  CLS TEXT
  PRINT "This Is Screen 2"
  PRINT "You typed :";a$
  IF UCASE$(a$)="STOP" THEN END
  CloseScreen screen2
NEXT

'***************************************************************************
'This sub establishes the virtual screen with all related parameters
'It keeps track of the cursor position, which can be saved with
'the SaveCursor subroutine.
'***************************************************************************

SUB OpenScreen(scr as Virscreen)
	'RESTORESCREEN scr                 'Not implemented yet
	COLOR scr.Fore,Scr.Back

	'This next one is not necessary once SAVREST is implemented.

	ReAttr Scr.UpperRow,Scr.LeftColumn, Scr.NumberOfRows, _
     Scr.NumberOfColumns, Scr.Back*16+Scr.Fore

	VIEW TEXT (Scr.LeftColumn,Scr.UpperRow)- _
     (Scr.LeftColumn+Scr.NumberOfColumns-1,Scr.UpperRow+Scr.NumberOfrows-1)

	LOCATE Scr.Xcursor,Scr.Ycursor
END SUB

'Currently, this SUB only saves the cursor location, but it might be expanded
'to do some more bookkeeping.

SUB CloseScreen(scr as Virscreen)
Scr.Xcursor=CSRLIN
Scr.Ycursor=Pos(0)
'SAVESCREEN Scr   'not implemented yet
END SUB

SUB MoveScreen(scr as Virscreen,Xpos?,Ypos?)
'Once save/restore is implemented I will add this.
'You only pass the new upperleftcorner, because
'everything else is relative to that.
END SUB



SUB ReAttr(UpperRow%, LeftCol%, NumRows%, NumCols%, Atr%) PUBLIC
'PB3 ASM (C) Thaddy de Koning, Adapted from Dave Navarro's .OBJ

		!clc
		!push ds
		!push es
		!mov ah,&h0F                            'Functie &h0F
		!int &h10                               'van Video interrupt &h10:Video
		!cmp al,7                               'Is gelijk 7? dan Mono
		!jne KolorCard                          'anders kleur
		!mov bx,&HB000                          'Mono Kaart adres
		!mov dx,&H3BA                           'Mono Poort adres
		!jmp short GetParameters                'Ok, ga maar een beetje rekenen
KolorCard:
		!mov bx,&HB800                          'KleurenKaart adres
		!mov dx,&H3DA                           'KleurenPoort adres
Getparameters:
		!push bx 'Bewaar kaart op de stack
		!pop es
		!lds si,dword ptr NumRows%              'Aantal rijen in si
		!mov cx,[si]                            'We gebruiken cx als teller voor rijen
		!push cx 'En bewaren de teller even op de stack
		!push dx 'samen met het segment
		!xor bx,bx                              'we maken bx schoon =0
		!mov bl,ah                              '
		!push bx
		!lds si,dword ptr UpperRow%
		!mov ax,[si]                            'aantal rijen in ax
		!dec ax 'minus 1
		!mul bx
		!shl ax,1 'maal twee voor het attribuut
		!lds si,dword ptr LeftCol%
		!mov bx,[si]                            'Kolom in bx
		!dec bx 'minus 1
		!shl bx,1 'maal twee voor het attribuut
		!add bx,ax                              'Totaal BYTEs nodig
		!mov di,bx
		!lds si,dword ptr atr%
		!mov ax,[si]
		!cld
		!lds si,dword ptr NumCols%
		!mov si,[si]
		!pop bx
		!shl bx,1
		!pop dx
HoofdLus:
		!push di
		!cli
		!mov cx,si
		!push ax
CGASYNCNODIG:
		!in al,dx 'Naar de videodeur
		!test al,8                              '
		!jnz ToegangOK
		!rcr al,1
		!jc CGASYNCNODIG
WachtOpSync:
		!in al,dx
		!rcr al,1
		!jnc WachtOpSync
ToegangOk:
		!pop ax
DoeEenRegel:
		!inc di
		!stosb
		!loop DoeEenRegel
		!sti
		!pop di
		!pop cx
		!dec cx
		!jcxz Fini                              'Klaar als cx =0, alle regels gedaan
		!push cx
		!add di,bx
		!jmp short HoofdLus                     'Nieuwe regel
Fini:
		!pop es
		!pop ds
END SUB
_
