; Whistle - Wolf's whistle
;
	public	whistle

I8253   equ     40h             ;Timer chip base address
I8255   equ     60h             ;PPI chip base address

ret_n	macro
	db	0c3h
	endm

cseg	segment para public 'CODE'
	assume cs:cseg, es:nothing, ds:nothing

Whistle proc	far
        push    AX
        mov     AL,0B6h         ;Counter 2, 2 bytes count, mode 3
        out     (I8253+3),AL    ;Write Mode Word
        mov     AX,1000         ;Divisor
        push    AX
        out     (I8253+2),AL    ;load lo byte
        xchg    AH,AL
        out     (I8253+2),AL    ;load hi byte
        in      AL,(I8255+1)    ;8255, port B
        or      AL,3            ;turn on bottom two bits, spkr on
        out     (I8255+1),AL
        pop     AX
W1:     call    SwLoop          ;soft timing loop
        dec     AX
        out     (I8253+2),AL    ;load lo byte
        xchg    AH,AL
        out     (I8253+2),AL    ;load hi byte
        xchg    AH,AL
        jne     W1              ;loop
        in      AL,(I8255+1)    ;8255, port B
        and     AL,NOT 3        ;turn off bottom two bits, spkr off
        out     (I8255+1),AL
        pop     AX
        retf	0
Whistle endp
;
; Soft loop for Whistle
;
SwLoop: push    CX
        mov     CX,30
SWL:    loop    SWL
        pop     CX
        ret_n
cseg    ends
        End
